OGRE: Ogre::SceneManager Class Reference

| OGRE 14.5 Object-Oriented Graphics Rendering Engine

Loading...
Searching...
No Matches
Ogre::SceneManager Class Referenceabstract
Core » Scene

Manages the organisation and rendering of a 'scene': a collection of objects and potentially world geometry. More...

`#include <OgreSceneManager.h>`

Inheritance diagram for Ogre::SceneManager:
[legend]

## Classes
class | Listener
| Class that allows listening in on the various stages of SceneManager processing, so that custom behaviour can be implemented from outside. More...
struct | RenderContext
class | SceneMgrQueuedRenderableVisitor
| Inner helper class to implement the visitor pattern for rendering objects in a queue. More...
struct | SkyBoxGenParameters
struct | SkyDomeGenParameters
struct | SkyPlaneGenParameters

## Public Types
typedef MapIterator< AnimationList > | AnimationIterator
typedef MapIterator< CameraList > | CameraIterator
typedef std::map< String, Camera * > | CameraList
enum | IlluminationRenderStage { IRS_NONE , IRS_RENDER_TO_TEXTURE , IRS_RENDER_RECEIVER_PASS }
| Describes the stage of rendering when performing complex illumination. More...
typedef MapIterator< MovableObjectMap > | MovableObjectIterator
typedef std::map< String, MovableObject * > | MovableObjectMap
enum | QueryTypeMask : uint32 { WORLD_GEOMETRY_TYPE_MASK = 0x80000000 , ENTITY_TYPE_MASK = 0x40000000 , FX_TYPE_MASK = 0x20000000 , STATICGEOMETRY_TYPE_MASK = 0x10000000 , LIGHT_TYPE_MASK = 0x08000000 , FRUSTUM_TYPE_MASK = 0x04000000 , USER_TYPE_MASK_LIMIT = FRUSTUM_TYPE_MASK }
enum | SpecialCaseRenderQueueMode { SCRQM_INCLUDE , SCRQM_EXCLUDE }
| Enumeration of the possible modes allowed for processing the special case render queue list. More...
typedef std::map< String, StaticGeometry * > | StaticGeometryMap
Public Types inherited from Ogre::AnimationContainer
typedef std::map< String, Animation * > | AnimationList

## Public Member Functions
| SceneManager (const String &instanceName)
| Constructor.
virtual | ~SceneManager ()
| Default destructor.
virtual void | _findVisibleObjects (Camera *cam, VisibleObjectsBoundsInfo *visibleBounds, bool onlyShadowCasters)
| Internal method which parses the scene to find visible objects to render.
CompositorChain * | _getActiveCompositorChain () const
| Gets the active compositor chain of the current scene being rendered.
const AutoParamDataSource * | _getAutoParamDataSource () const
uint32 | _getCombinedVisibilityMask (void) const
| Internal method for getting the combination between the global visibility mask and the per-viewport visibility mask.
IlluminationRenderStage | _getCurrentRenderStage () const
void | _handleLodEvents ()
| Handle LOD events.
void | _injectRenderWithPass (Pass *pass, Renderable *rend, bool shadowDerivation=true, bool doLightIteration=false, const LightList *manualLightList=0)
| Render something as if it came from the current queue.
void | _issueRenderOp (Renderable *rend, const Pass *pass)
| Internal method for issuing the render operation.
void | _markGpuParamsDirty (uint16 mask)
| Method to allow you to mark gpu parameters as dirty, causing them to be updated according to the mask that you set when updateGpuProgramParameters is next called.
void | _notifyAutotrackingSceneNode (SceneNode *node, bool autoTrack)
| Internal method for notifying the manager that a SceneNode is autotracking.
void | _notifyEntityMaterialLodChanged (EntityMaterialLodChangedEvent &evt)
| Notify that an entity material LOD change event has occurred.
void | _notifyEntityMeshLodChanged (EntityMeshLodChangedEvent &evt)
| Notify that an entity mesh LOD change event has occurred.
void | _notifyMovableObjectLodChanged (MovableObjectLodChangedEvent &evt)
| Notify that a movable object LOD change event has occurred.
RenderContext * | _pauseRendering ()
| Pause rendering of the frame.
void | _releaseManualHardwareResources ()
| Notifies the scene manager that hardware resources were lost.
void | _renderQueueGroupObjects (RenderQueueGroup *group, QueuedRenderableCollection::OrganisationMode om)
| Render the objects in a given queue group.
virtual void | _renderScene (Camera *camera, Viewport *vp, bool includeOverlays=true)
| Prompts the class to send its contents to the renderer.
void | _renderVisibleObjects (void)
| Sends visible objects found in _findVisibleObjects to the rendering engine.
void | _restoreManualHardwareResources ()
| Notifies the scene manager that hardware resources should be restored.
void | _resumeRendering (RenderContext *context)
| Resume rendering of the frame.
void | _setActiveCompositorChain (CompositorChain *chain)
| Sets the active compositor chain of the current scene being rendered.
void | _setDestinationRenderSystem (RenderSystem *sys)
| Notifies the scene manager of its destination render system.
const Pass * | _setPass (const Pass *pass, bool shadowDerivation=true)
| Internal method for setting up the renderstate for a rendering pass.
virtual void | _updateSceneGraph (Camera *cam)
| Internal method for updating the scene graph ie the tree of SceneNode instances managed by this class.
void | addListener (Listener *s)
| Add a listener which will get called back on scene manager events.
void | addLodListener (LodListener *listener)
| Add a level of detail listener.
void | addRenderObjectListener (RenderObjectListener *newListener)
| Registers a new Render Object Listener which will be notified when rendering an object.
void | addRenderQueueListener (RenderQueueListener *newListener)
| Registers a new RenderQueueListener which will be notified when render queues are processed.
void | addShadowTextureListener (ShadowTextureListener *s)
| Add a listener which will get called back on shadow texture events.
void | addSpecialCaseRenderQueue (uint8 qid)
| Adds an item to the 'special case' render queue list.
virtual void | clearScene (void)
| Empties the entire scene, including all SceneNodes, Entities, Lights, BillboardSets etc.
void | clearSpecialCaseRenderQueues (void)
| Clears the 'special case' render queue list.
const ColourValue & | getAmbientLight (void) const
| Returns the ambient light level to be used for the scene.
Viewport * | getCurrentViewport (void) const
| Gets the current viewport being rendered (advanced use only, only valid during viewport update.
RenderSystem * | getDestinationRenderSystem ()
| Get the rendersystem subclass to which the output of this Scene Manager gets sent.
bool | getFindVisibleObjects (void)
| Gets whether the SceneManager should search for visible objects, or whether they are being manually handled.
bool | getFlipCullingOnNegativeScale () const
| Get whether to automatically flip the culling mode on objects whenever they are negatively scaled.
const String & | getName (void) const
| Return the instance name of this SceneManager.
virtual bool | getOption (const String &strKey, void *pDestValue)
| Method for getting the value of an implementation-specific Scene Manager option.
virtual bool | getOptionKeys (StringVector &refKeys)
| Method for getting all the implementation-specific options of the scene manager.
virtual bool | getOptionValues (const String &strKey, StringVector &refValueList)
| Method for getting all possible values for a specific option.
SceneMgrQueuedRenderableVisitor * | getQueuedRenderableVisitor (void) const
| Gets the current visitor object which processes queued renderables.
RenderQueue * | getRenderQueue (void)
| Retrieves the internal render queue, for advanced users only.
const VisibleObjectsBoundsInfo & | getShadowCasterBoundsInfo (const Light *light, size_t iteration=0) const
SpecialCaseRenderQueueMode | getSpecialCaseRenderQueueMode (void)
| Gets the way the special case render queue list is processed.
virtual ViewPoint | getSuggestedViewpoint (bool random=false)
| Asks the SceneManager to provide a suggested viewpoint from which the scene should be viewed.
virtual const String & | getTypeName (void) const =0
| Retrieve the type name of this scene manager.
uint32 | getVisibilityMask (void)
| Gets a mask which is bitwise 'and'ed with objects own visibility masks to determine if the object is visible.
const VisibleObjectsBoundsInfo & | getVisibleObjectsBoundsInfo (const Camera *cam) const
| Returns a visibility boundary box for a specific camera.
uint8 | getWorldGeometryRenderQueue ()
| Gets the render queue that the world geometry (if any) this SceneManager renders will be associated with.
virtual bool | hasOption (const String &strKey) const
| Method for verifying whether the scene manager has an implementation-specific option.
bool | isLateMaterialResolving () const
| Gets whether using late material resolving or not.
bool | isRenderQueueToBeProcessed (uint8 qid)
| Returns whether or not the named queue will be rendered based on the current 'special case' render queue list and mode.
void | manualRender (Renderable *rend, const Pass *pass, Viewport *vp, const Affine3 &viewMatrix, const Matrix4 &projMatrix, bool doBeginEndFrame=false, bool lightScissoringClipping=true, bool doLightIteration=true, const LightList *manualLightList=0)
| Manual rendering method for rendering a single object.
void | manualRender (RenderOperation *rend, Pass *pass, Viewport *vp, const Affine3 &worldMatrix, const Affine3 &viewMatrix, const Matrix4 &projMatrix, bool doBeginEndFrame=false)
| Manual rendering method, for advanced users only.
| OGRE_MUTEX (sceneGraphMutex)
| Mutex to protect the scene graph from simultaneous access from multiple threads.
void | removeListener (Listener *s)
| Remove a listener.
void | removeLodListener (LodListener *listener)
| Remove a level of detail listener.
void | removeRenderObjectListener (RenderObjectListener *delListener)
| Removes a listener previously added with addRenderObjectListener.
void | removeRenderQueueListener (RenderQueueListener *delListener)
| Removes a listener previously added with addRenderQueueListener.
void | removeShadowTextureListener (ShadowTextureListener *s)
| Remove a listener.
void | removeSpecialCaseRenderQueue (uint8 qid)
| Removes an item to the 'special case' render queue list.
void | setAmbientLight (const ColourValue &colour)
| Sets the ambient light level to be used for the scene.
void | setFindVisibleObjects (bool find)
| Sets whether the SceneManager should search for visible objects, or whether they are being manually handled.
void | setFlipCullingOnNegativeScale (bool n)
| Set whether to automatically flip the culling mode on objects whenever they are negatively scaled.
void | setLateMaterialResolving (bool isLate)
| Sets whether to use late material resolving or not.
virtual bool | setOption (const String &strKey, const void *pValue)
| Method for setting a specific option of the Scene Manager.
void | setQueuedRenderableVisitor (SceneMgrQueuedRenderableVisitor *visitor)
| Advanced method for supplying an alternative visitor, used for parsing the render queues and sending the results to the renderer.
void | setSpecialCaseRenderQueueMode (SpecialCaseRenderQueueMode mode)
| Sets the way the special case render queue list is processed.
void | setVisibilityMask (uint32 vmask)
| Sets a mask which is bitwise 'and'ed with objects own visibility masks to determine if the object is visible.
void | setVPRTCameras (const std::vector< const Camera * > &cameras) const
void | setWorldGeometryRenderQueue (uint8 qid)
| Sets the render queue that the world geometry (if any) this SceneManager renders will be associated with.
Cameras
virtual Camera * | createCamera (const String &name)
| Creates a camera to be managed by this scene manager.
Camera * | getCamera (const String &name) const
| Retrieves a pointer to the named camera.
bool | hasCamera (const String &name) const
| Returns whether a camera with the given name exists.
void | destroyCamera (Camera *cam)
| Removes a camera from the scene.
void | destroyCamera (const String &name)
| Removes a camera from the scene.
void | destroyAllCameras (void)
| Removes (and destroys) all cameras from the scene.
void | setCameraRelativeRendering (bool rel)
| Set whether to use camera-relative coordinates when rendering, ie to always place the camera at the origin and move the world around it.
bool | getCameraRelativeRendering () const
| Get whether to use camera-relative coordinates when rendering, ie to always place the camera at the origin and move the world around it.
CameraIterator | getCameraIterator (void)
| Returns a specialised MapIterator over all cameras in the scene.
const CameraList & | getCameras () const
| Returns a const version of the camera list.
Lights
virtual Light * | createLight (const String &name)
| Creates a light for use in the scene.
Light * | createLight (const String &name, Light::LightTypes type)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
virtual Light * | createLight ()
| Creates a light with a generated name.
Light * | createLight (Light::LightTypes type)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
virtual Light * | getLight (const String &name) const
| Get a reference to a previously created object instance.
virtual bool | hasLight (const String &name) const
| Returns whether a object instance with the given name exists.
const PlaneList & | getLightClippingPlanes (Light *l)
| Retrieve a set of clipping planes for a given light.
const RealRect & | getLightScissorRect (Light *l, const Camera *cam)
| Retrieve a scissor rectangle for a given light and camera.
virtual void | invalidatePerFrameScissorRectCache ()
| Scissor rects are cached during frame, and this cache should be explicitly invalidated if several renders are done during one frame using different projections matrices, for example for tiled, stereo or multiview orthographic projection rendering.
virtual void | destroyLight (const String &name)
| Removes the light from the scene and destroys it.
void | destroyLight (Light *light)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
virtual void | destroyAllLights (void)
| Removes and destroys all lights in the scene.
void | _notifyLightsDirty (void)
| Advanced method to increase the lights dirty counter due to lights having changed.
ulong | _getLightsDirtyCounter (void) const
| Advanced method to gets the lights dirty counter.
const LightList & | _getLightsAffectingFrustum (void) const
| Get the list of lights which could be affecting the frustum.
void | _populateLightList (const Vector3 &position, Real radius, LightList &destList, uint32 lightMask=0xFFFFFFFF)
| Populate a light list with an ordered set of the lights which are closest to the position specified.
void | _populateLightList (const SceneNode *sn, Real radius, LightList &destList, uint32 lightMask=0xFFFFFFFF)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
Scene Nodes
SceneNode * | createSceneNode (void)
| Creates an instance of a SceneNode.
SceneNode * | createSceneNode (const String &name)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
virtual void | destroySceneNode (SceneNode *sn)
| Destroys a SceneNode.
void | destroySceneNode (const String &name)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
SceneNode * | getRootSceneNode (void)
| Gets the SceneNode at the root of the scene hierarchy.
SceneNode * | getSceneNode (const String &name, bool throwExceptionIfNotFound=true) const
| Retrieves a named SceneNode from the scene graph.
bool | hasSceneNode (const String &name) const
| Returns whether a scene node with the given name exists.
void | setDisplaySceneNodes (bool display)
| Tells the SceneManager whether it should render the SceneNodes which make up the scene as well as the objects in the scene.
bool | getDisplaySceneNodes (void) const
| Returns true if all scene nodes axis are to be displayed.
void | showBoundingBoxes (bool bShow)
| Allows all bounding boxes of scene nodes to be displayed.
bool | getShowBoundingBoxes () const
| Returns if all bounding boxes of scene nodes are to be displayed.
DebugDrawer * | getDebugDrawer () const
Entities
Entity * | createEntity (const String &entityName, const String &meshName, const String &groupName=ResourceGroupManager::AUTODETECT_RESOURCE_GROUP_NAME)
| Create an Entity (instance of a discrete mesh).
Entity * | createEntity (const String &entityName, const MeshPtr &pMesh)
| Create an Entity (instance of a discrete mesh).
Entity * | createEntity (const String &meshName)
| Create an Entity (instance of a discrete mesh) with an autogenerated name.
Entity * | createEntity (const MeshPtr &pMesh)
| Create an Entity (instance of a discrete mesh) with an autogenerated name.
Entity * | getEntity (const String &name) const
| Get a reference to a previously created object instance.
bool | hasEntity (const String &name) const
| Returns whether a object instance with the given name exists.
void | destroyEntity (MovableObject *ent)
| Removes & destroys an Entity from the SceneManager.
void | destroyEntity (const String &name)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
void | destroyAllEntities (void)
| Removes & destroys all Entities.
Manual Objects
ManualObject * | createManualObject (const String &name)
| Create a ManualObject, an object which you populate with geometry manually through a GL immediate-mode style interface.
ManualObject * | createManualObject ()
| Create a ManualObject, an object which you populate with geometry manually through a GL immediate-mode style interface, generating the name.
ManualObject * | getManualObject (const String &name) const
| Get a reference to a previously created object instance.
bool | hasManualObject (const String &name) const
| Returns whether a object instance with the given name exists.
void | destroyManualObject (MovableObject *obj)
| Removes & destroys a ManualObject from the SceneManager.
void | destroyManualObject (const String &name)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
void | destroyAllManualObjects (void)
| Removes & destroys all ManualObjects from the SceneManager.
Screenspace Rectangles
Rectangle2D * | createScreenSpaceRect (const String &name, bool includeTextureCoords=false)
| Creates a Rectangle2D that can be displayed for screen space effects or showing a basic GUI.
Rectangle2D * | createScreenSpaceRect (bool includeTextureCoords=false)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
bool | hasScreenSpaceRect (const String &name) const
| Returns whether a object instance with the given name exists.
Rectangle2D * | getScreenSpaceRect (const String &name) const
| Get a reference to a previously created object instance.
Billboard Chains
BillboardChain * | createBillboardChain (const String &name)
| Create a BillboardChain, an object which you can use to render a linked chain of billboards.
BillboardChain * | createBillboardChain ()
| Create a BillboardChain, an object which you can use to render a linked chain of billboards, with a generated name.
BillboardChain * | getBillboardChain (const String &name) const
| Get a reference to a previously created object instance.
bool | hasBillboardChain (const String &name) const
| Returns whether a object instance with the given name exists.
void | destroyBillboardChain (MovableObject *obj)
| Removes & destroys a BillboardChain from the SceneManager.
void | destroyBillboardChain (const String &name)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
void | destroyAllBillboardChains (void)
| Removes & destroys all BillboardChains from the SceneManager.
RibbonTrail * | createRibbonTrail (const String &name)
| Create a RibbonTrail, an object which you can use to render a linked chain of billboards which follows one or more nodes.
RibbonTrail * | createRibbonTrail ()
| Create a RibbonTrail, an object which you can use to render a linked chain of billboards which follows one or more nodes, generating the name.
RibbonTrail * | getRibbonTrail (const String &name) const
| Get a reference to a previously created object instance.
bool | hasRibbonTrail (const String &name) const
| Returns whether a object instance with the given name exists.
void | destroyRibbonTrail (MovableObject *obj)
| Removes & destroys a RibbonTrail from the SceneManager.
void | destroyRibbonTrail (const String &name)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
void | destroyAllRibbonTrails (void)
| Removes & destroys all RibbonTrails from the SceneManager.
Particle System
ParticleSystem * | createParticleSystem (const String &name, const String &templateName)
| Creates a particle system based on a template.
ParticleSystem * | createParticleSystem (const String &name, size_t quota=500, const String &resourceGroup=ResourceGroupManager::DEFAULT_RESOURCE_GROUP_NAME)
| Create a blank particle system.
ParticleSystem * | createParticleSystem (size_t quota=500, const String &resourceGroup=ResourceGroupManager::DEFAULT_RESOURCE_GROUP_NAME)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
ParticleSystem * | getParticleSystem (const String &name) const
| Get a reference to a previously created object instance.
bool | hasParticleSystem (const String &name) const
| Returns whether a object instance with the given name exists.
void | destroyParticleSystem (MovableObject *obj)
| Removes & destroys a ParticleSystem from the SceneManager.
void | destroyParticleSystem (const String &name)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
void | destroyAllParticleSystems (void)
| Removes & destroys all ParticleSystems from the SceneManager.
World Geometry
virtual void | setWorldGeometry (const String &filename)
| Sets the source of the 'world' geometry, i.e.
virtual void | setWorldGeometry (DataStreamPtr &stream, const String &typeName=BLANKSTRING)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
virtual size_t | estimateWorldGeometry (const String &filename)
| Estimate the number of loading stages required to load the named world geometry.
virtual size_t | estimateWorldGeometry (DataStreamPtr &stream, const String &typeName=BLANKSTRING)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
Sky Rendering
void | setSkyRenderingEnabled (bool enable)
| Enables / disables a 'sky'.
bool | isSkyRenderingEnabled (void) const
| Return whether a sky is enabled.
SceneNode * | getSkyNode (void) const
| Get the sky node, if enabled.
void | setSkyPlane (bool enable, const Plane &plane, const String &materialName, Real scale=1000, Real tiling=10, bool drawFirst=true, Real bow=0, int xsegments=1, int ysegments=1, const String &groupName=ResourceGroupManager::AUTODETECT_RESOURCE_GROUP_NAME)
| Enables / disables a 'sky plane' i.e.
void | _setSkyPlane (bool enable, const Plane &plane, const String &materialName, Real scale=1000, Real tiling=10, uint8 renderQueue=RENDER_QUEUE_SKIES_EARLY, Real bow=0, int xsegments=1, int ysegments=1, const String &groupName=ResourceGroupManager::AUTODETECT_RESOURCE_GROUP_NAME)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
void | setSkyPlaneEnabled (bool enable)
bool | isSkyPlaneEnabled (void) const
SceneNode * | getSkyPlaneNode (void) const
SkyPlaneGenParameters | getSkyPlaneGenParameters (void) const
void | setSkyBox (bool enable, const String &materialName, Real distance=5000, bool drawFirst=true, const Quaternion &orientation=Quaternion::IDENTITY, const String &groupName=ResourceGroupManager::AUTODETECT_RESOURCE_GROUP_NAME)
| Enables / disables a 'sky box' i.e.
void | _setSkyBox (bool enable, const String &materialName, Real distance=5000, uint8 renderQueue=RENDER_QUEUE_SKIES_EARLY, const Quaternion &orientation=Quaternion::IDENTITY, const String &groupName=ResourceGroupManager::AUTODETECT_RESOURCE_GROUP_NAME)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
void | setSkyBoxEnabled (bool enable)
bool | isSkyBoxEnabled (void) const
SceneNode * | getSkyBoxNode (void) const
SkyBoxGenParameters | getSkyBoxGenParameters (void) const
void | setSkyDome (bool enable, const String &materialName, Real curvature=10, Real tiling=8, Real distance=4000, bool drawFirst=true, const Quaternion &orientation=Quaternion::IDENTITY, int xsegments=16, int ysegments=16, int ysegments_keep=-1, const String &groupName=ResourceGroupManager::AUTODETECT_RESOURCE_GROUP_NAME)
| Enables / disables a 'sky dome' i.e.
void | _setSkyDome (bool enable, const String &materialName, Real curvature=10, Real tiling=8, Real distance=4000, uint8 renderQueue=RENDER_QUEUE_SKIES_EARLY, const Quaternion &orientation=Quaternion::IDENTITY, int xsegments=16, int ysegments=16, int ysegments_keep=-1, const String &groupName=ResourceGroupManager::AUTODETECT_RESOURCE_GROUP_NAME)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
void | setSkyDomeEnabled (bool enable)
bool | isSkyDomeEnabled (void) const
SceneNode * | getSkyDomeNode (void) const
SkyDomeGenParameters | getSkyDomeGenParameters (void) const
Fogging
void | setFog (FogMode mode=FOG_NONE, const ColourValue &colour=ColourValue::White, Real expDensity=0.001f, Real linearStart=0.0f, Real linearEnd=1.0f)
| Sets the fogging mode applied to the scene.
FogMode | getFogMode (void) const
| Returns the fog mode for the scene.
const ColourValue & | getFogColour (void) const
| Returns the fog colour for the scene.
Real | getFogStart (void) const
| Returns the fog start distance for the scene.
Real | getFogEnd (void) const
| Returns the fog end distance for the scene.
Real | getFogDensity (void) const
| Returns the fog density for the scene.
Billboard Sets
BillboardSet * | createBillboardSet (unsigned int poolSize=20)
| Creates a new BillboardSet for use with this scene manager.
BillboardSet * | createBillboardSet (const String &name, unsigned int poolSize=20)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
BillboardSet * | getBillboardSet (const String &name) const
| Retrieves a pointer to the named BillboardSet.
bool | hasBillboardSet (const String &name) const
| Returns whether a billboardset with the given name exists.
void | destroyBillboardSet (MovableObject *set)
| Removes & destroys an BillboardSet from the SceneManager.
void | destroyBillboardSet (const String &name)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
void | destroyAllBillboardSets (void)
| Removes & destroys all BillboardSets.
Scene Node Animation
void | _applySceneAnimations (void)
| Internal method for applying animations to scene nodes.
Animation * | createAnimation (const String &name, Real length) override
| Creates an animation which can be used to animate scene nodes.
Animation * | getAnimation (const String &name) const override
| Looks up an Animation object previously created with createAnimation.
bool | hasAnimation (const String &name) const override
| Returns whether this object contains the named animation.
uint16 | getNumAnimations (void) const override
| Gets the number of animations in this container.
Animation * | getAnimation (unsigned short index) const override
| Retrieve an animation by index.
void | removeAnimation (const String &name) override
| Remove & destroy an Animation from this container.
void | destroyAnimation (const String &name)
void | destroyAllAnimations (void)
| Removes all animations created using this SceneManager.
AnimationState * | createAnimationState (const String &animName)
| Create an AnimationState object for managing application of animations.
AnimationState * | getAnimationState (const String &animName) const
| Retrieves animation state as previously created using createAnimationState.
bool | hasAnimationState (const String &name) const
| Returns whether an animation state with the given name exists.
void | destroyAnimationState (const String &name)
| Destroys an AnimationState.
void | destroyAllAnimationStates (void)
| Removes all animation states created using this SceneManager.
AnimationIterator | getAnimationIterator (void)
| Returns a specialised MapIterator over all animations in the scene.
const AnimationList & | getAnimations () const
| Returns a const version of the animation list.
AnimationStateIterator | getAnimationStateIterator (void)
| Returns a specialised MapIterator over all animation states in the scene.
const AnimationStateMap & | getAnimationStates ()
| Returns a specialised Map over all animation states in the scene.
Scene Queries
virtual AxisAlignedBoxSceneQuery * | createAABBQuery (const AxisAlignedBox &box, uint32 mask=0xFFFFFFFF)
| Creates an AxisAlignedBoxSceneQuery for this scene manager.
virtual SphereSceneQuery * | createSphereQuery (const Sphere &sphere, uint32 mask=0xFFFFFFFF)
| Creates a SphereSceneQuery for this scene manager.
virtual PlaneBoundedVolumeListSceneQuery * | createPlaneBoundedVolumeQuery (const PlaneBoundedVolumeList &volumes, uint32 mask=0xFFFFFFFF)
| Creates a PlaneBoundedVolumeListSceneQuery for this scene manager.
virtual RaySceneQuery * | createRayQuery (const Ray &ray, uint32 mask=0xFFFFFFFF)
| Creates a RaySceneQuery for this scene manager.
virtual IntersectionSceneQuery * | createIntersectionQuery (uint32 mask=0xFFFFFFFF)
| Creates an IntersectionSceneQuery for this scene manager.
void | destroyQuery (SceneQuery *query)
| Destroys a scene query of any type.
Generic Shadows Config
void | setShadowTechnique (ShadowTechnique technique)
| Sets the general shadow technique to be used in this scene.
ShadowTechnique | getShadowTechnique (void) const
| Gets the current shadow technique.
void | setShadowColour (const ColourValue &colour)
| Set the colour used to modulate areas in shadow.
const ColourValue & | getShadowColour (void) const
| Get the colour used to modulate areas in shadow.
void | setShadowDirectionalLightExtrusionDistance (Real dist)
| Sets the distance a shadow volume is extruded for a directional light.
Real | getShadowDirectionalLightExtrusionDistance (void) const
| Gets the distance a shadow volume is extruded for a directional light.
bool | isShadowTechniqueStencilBased (void) const
| Is there a stencil shadow based shadowing technique in use?
bool | isShadowTechniqueTextureBased (void) const
| Is there a texture shadow based shadowing technique in use?
bool | isShadowTechniqueModulative (void) const
| Is there a modulative shadowing technique in use?
bool | isShadowTechniqueAdditive (void) const
| Is there an additive shadowing technique in use?
bool | isShadowTechniqueIntegrated (void) const
| Is the shadow technique integrated into primary materials?
bool | isShadowTechniqueInUse (void) const
| Is there any shadowing technique in use?
Stencil Shadows Config
void | setShowDebugShadows (bool debug)
| Enables / disables the rendering of debug information for shadows.
bool | getShowDebugShadows (void) const
| Are debug shadows shown?
void | setShadowIndexBufferSize (size_t size)
| Sets the maximum size of the index buffer used to render shadow primitives.
size_t | getShadowIndexBufferSize (void) const
| Get the size of the shadow index buffer.
void | setShadowUseInfiniteFarPlane (bool enable)
| Sets whether we should use an infinite camera far plane when rendering stencil shadows.
void | setShadowUseLightClipPlanes (bool enabled)
| Sets whether when using a built-in additive shadow mode, user clip planes should be used to restrict light rendering.
bool | getShadowUseLightClipPlanes () const
| Gets whether when using a built-in additive shadow mode, user clip planes should be used to restrict light rendering.
Texture Shadows Config
void | setShadowFarDistance (Real distance)
| Sets the default maximum distance away from the camera that shadows will be visible.
Real | getShadowFarDistance (void) const
| Gets the default maximum distance away from the camera that shadows will be visible.
Real | getShadowFarDistanceSquared (void) const
virtual void | updateShadowTextures (Camera *cam, Viewport *vp, const LightList *lightList=0)
| Method for update shadow textures ready for use in a regular render Do not call manually unless before frame start or rendering is paused If lightList is not supplied, will render all lights in frustum.
void | prepareShadowTextures (Camera *cam, Viewport *vp, const LightList *lightList=0)
void | setShadowTextureSize (unsigned short size)
| Set the size of the texture used for all texture-based shadows.
void | setShadowTextureConfig (size_t shadowIndex, uint16 width, uint16 height, PixelFormat format, uint16 fsaa=0, uint16 depthBufferPoolId=1)
| Set the detailed configuration for a shadow texture.
void | setShadowTextureConfig (size_t shadowIndex, const ShadowTextureConfig &config)
| Set the detailed configuration for a shadow texture.
const ShadowTextureConfigList & | getShadowTextureConfigList () const
| Get the current shadow texture settings.
ConstShadowTextureConfigIterator | getShadowTextureConfigIterator () const
void | setShadowTexturePixelFormat (PixelFormat fmt)
| Set the pixel format of the textures used for texture-based shadows.
void | setShadowTextureFSAA (unsigned short fsaa)
| Set the level of multisample AA of the textures used for texture-based shadows.
void | setShadowTextureCount (size_t count)
| Set the number of textures allocated for texture-based shadows.
size_t | getShadowTextureCount (void) const
void | setShadowTextureCountPerLightType (Light::LightTypes type, size_t count)
| Set the number of shadow textures a light type uses.
size_t | getShadowTextureCountPerLightType (Light::LightTypes type) const
| Get the number of shadow textures is assigned for the given light type.
void | setShadowTextureSettings (uint16 size, uint16 count, PixelFormat fmt=PF_BYTE_RGBA, uint16 fsaa=0, uint16 depthBufferPoolId=1)
| Sets the size and count of textures used in texture-based shadows.
void | setShadowTextureCompositor (const String &compositorName, const String &resourceGroup=RGN_DEFAULT)
| Sets the configuration of textures used for texture-based shadows.
const TexturePtr & | getShadowTexture (size_t shadowIndex)
| Get a reference to the shadow texture currently in use at the given index.
void | setShadowDirLightTextureOffset (Real offset)
| Sets the proportional distance which a texture shadow which is generated from a directional light will be offset into the camera view to make best use of texture space.
Real | getShadowDirLightTextureOffset (void) const
| Gets the proportional distance which a texture shadow which is generated from a directional light will be offset into the camera view to make best use of texture space.
void | setShadowTextureFadeStart (Real fadeStart)
| Sets the proportional distance at which texture shadows begin to fade out.
void | setShadowTextureFadeEnd (Real fadeEnd)
| Sets the proportional distance at which texture shadows finish to fading out.
void | setShadowTextureSelfShadow (bool selfShadow)
| Sets whether or not texture shadows should attempt to self-shadow.
bool | getShadowTextureSelfShadow (void) const
| Gets whether or not texture shadows attempt to self-shadow.
void | setShadowTextureCasterMaterial (const MaterialPtr &mat)
| Sets the default material to use for rendering shadow casters.
void | setShadowTextureReceiverMaterial (const MaterialPtr &mat)
| Sets the default material to use for rendering shadow receivers.
void | setShadowCasterRenderBackFaces (bool bf)
| Sets whether or not shadow casters should be rendered into shadow textures using their back faces rather than their front faces.
bool | getShadowCasterRenderBackFaces () const
| Gets whether or not shadow casters should be rendered into shadow textures using their back faces rather than their front faces.
void | setShadowCameraSetup (const ShadowCameraSetupPtr &shadowSetup)
| Set the shadow camera setup to use for all lights which don't have their own shadow camera setup.
const ShadowCameraSetupPtr & | getShadowCameraSetup () const
| Get the shadow camera setup in use for all lights which don't have their own shadow camera setup.
Static Geometry
StaticGeometry * | createStaticGeometry (const String &name)
| Creates a StaticGeometry instance suitable for use with this SceneManager.
StaticGeometry * | getStaticGeometry (const String &name) const
| Retrieve a previously created StaticGeometry instance.
bool | hasStaticGeometry (const String &name) const
| Returns whether a static geometry instance with the given name exists.
const StaticGeometryMap * | getStaticGeometryCollection () const
| Returns all static geometry instances with names.
void | destroyStaticGeometry (StaticGeometry *geom)
| Remove & destroy a StaticGeometry instance.
void | destroyStaticGeometry (const String &name)
| Remove & destroy a StaticGeometry instance.
void | destroyAllStaticGeometry (void)
| Remove & destroy all StaticGeometry instances.
Instancing
InstanceManager * | createInstanceManager (const String &customName, const String &meshName, const String &groupName, InstanceManager::InstancingTechnique technique, size_t numInstancesPerBatch, uint16 flags=0, unsigned short subMeshIdx=0)
| Creates an InstanceManager interface to create & manipulate instanced entities You need to call this function at least once before start calling createInstancedEntity to build up an instance based on the given mesh.
InstanceManager * | getInstanceManager (const String &managerName) const
| Retrieves an existing InstanceManager by it's name.
bool | hasInstanceManager (const String &managerName) const
| Returns whether an InstanceManager with the given name exists.
void | destroyInstanceManager (const String &name)
| Destroys an InstanceManager if it was created with createInstanceManager().
void | destroyInstanceManager (InstanceManager *instanceManager)
void | destroyAllInstanceManagers (void)
size_t | getNumInstancesPerBatch (const String &meshName, const String &groupName, const String &materialName, InstanceManager::InstancingTechnique technique, size_t numInstancesPerBatch, uint16 flags=0, unsigned short subMeshIdx=0)
InstancedEntity * | createInstancedEntity (const String &materialName, const String &managerName)
| Creates an InstancedEntity based on an existing InstanceManager.
void | destroyInstancedEntity (InstancedEntity *instancedEntity)
| Removes an InstancedEntity,.
void | _addDirtyInstanceManager (InstanceManager *dirtyManager)
| Called by an InstanceManager when it has at least one InstanceBatch that needs their bounds to be updated for proper culling.
Movable Objects
MovableObject * | createMovableObject (const String &name, const String &typeName, const NameValuePairList *params=0)
| Create a movable object of the type specified.
MovableObject * | createMovableObject (const String &typeName, const NameValuePairList *params=0)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
void | destroyMovableObject (const String &name, const String &typeName)
| Destroys a MovableObject with the name specified, of the type specified.
void | destroyMovableObject (MovableObject *m)
| Destroys a MovableObject.
void | destroyAllMovableObjectsByType (const String &typeName)
| Destroy all MovableObjects of a given type.
void | destroyAllMovableObjects (void)
| Destroy all MovableObjects.
MovableObject * | getMovableObject (const String &name, const String &typeName) const
| Get a reference to a previously created object instance.
bool | hasMovableObject (const String &name, const String &typeName) const
| Returns whether a object instance with the given name exists.
const MovableObjectMap & | getMovableObjects (const String &typeName)
| Get all MovableObect instances of a given type.
MovableObjectIterator | getMovableObjectIterator (const String &typeName)
void | injectMovableObject (MovableObject *m)
| Inject a MovableObject instance created externally.
void | extractMovableObject (const String &name, const String &typeName)
| Extract a previously injected MovableObject.
void | extractMovableObject (MovableObject *m)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
void | extractAllMovableObjectsByType (const String &typeName)
| Extract all injected MovableObjects of a given type.
Public Member Functions inherited from Ogre::AnimationContainer
virtual | ~AnimationContainer ()

## Static Public Member Functions
static bool | hasPerRenderableLights ()
static void | usePerRenderableLights (bool enabled)
| Toggle sorting of lights for each renderable.

## Static Public Attributes
static constexpr const char * | PT_CUBE = "Prefab_Cube"
| 100x100x100 cube centred at origin with normals and UVs
static constexpr const char * | PT_PLANE = "Prefab_Plane"
| XY plane with -100..100 extent, +Z normal and UVs.
static constexpr const char * | PT_SPHERE = "Prefab_Sphere"

## Detailed Description

Manages the organisation and rendering of a 'scene': a collection of objects and potentially world geometry.

This class defines the interface and the basic behaviour of a 'Scene Manager'. A SceneManager organises the culling and rendering of the scene, in conjunction with the RenderQueue. This class is designed to be extended through subclassing in order to provide more specialised scene organisation structures for particular needs. The default SceneManager culls based on a hierarchy of node bounding boxes, other implementations can use an octree (see OctreeSceneManager), a BSP tree (see BspSceneManager), and many other options. New SceneManager implementations can be added at runtime by plugins, see SceneManagerEnumerator for the interfaces for adding new SceneManager types.

There is a distinction between 'objects' (which subclass MovableObject, and are movable, discrete objects in the world), and 'world geometry', which is large, generally static geometry. World geometry tends to influence the SceneManager organisational structure (e.g. lots of indoor static geometry might result in a spatial tree structure) and as such world geometry is generally tied to a given SceneManager implementation, whilst MovableObject instances can be used with any SceneManager. Subclasses are free to define world geometry however they please.

Multiple SceneManager instances can exist at one time, each one with a distinct scene. Which SceneManager is used to render a scene is dependent on the Camera, which will always call back the SceneManager which created it to render the scene.

## Member Typedef Documentation

## ◆ CameraList

typedef std::map<String, Camera* > Ogre::SceneManager::CameraList

## ◆ MovableObjectMap

typedef std::map<String, MovableObject*> Ogre::SceneManager::MovableObjectMap

## ◆ StaticGeometryMap

typedef std::map<String, StaticGeometry* > Ogre::SceneManager::StaticGeometryMap

## ◆ CameraIterator

typedef MapIterator<CameraList> Ogre::SceneManager::CameraIterator

## ◆ AnimationIterator

typedef MapIterator<AnimationList> Ogre::SceneManager::AnimationIterator

## ◆ MovableObjectIterator

typedef MapIterator<MovableObjectMap> Ogre::SceneManager::MovableObjectIterator

## Member Enumeration Documentation

## ◆ QueryTypeMask

enum Ogre::SceneManager::QueryTypeMask : uint32

Enumerator
WORLD_GEOMETRY_TYPE_MASK | Query type mask which will be used for world geometry. See also SceneQuery
ENTITY_TYPE_MASK | Query type mask which will be used for entities. See also SceneQuery
FX_TYPE_MASK | Query type mask which will be used for effects like billboardsets / particle systems. See also SceneQuery
STATICGEOMETRY_TYPE_MASK | Query type mask which will be used for StaticGeometry. See also SceneQuery
LIGHT_TYPE_MASK | Query type mask which will be used for lights. See also SceneQuery
FRUSTUM_TYPE_MASK | Query type mask which will be used for frusta and cameras. See also SceneQuery
USER_TYPE_MASK_LIMIT | User type mask limit.

## ◆ IlluminationRenderStage

enum Ogre::SceneManager::IlluminationRenderStage

Describes the stage of rendering when performing complex illumination.

Enumerator
IRS_NONE | No special illumination stage.
IRS_RENDER_TO_TEXTURE | Render to texture stage, used for texture based shadows.
IRS_RENDER_RECEIVER_PASS | Render from shadow texture to receivers stage.

## ◆ SpecialCaseRenderQueueMode

enum Ogre::SceneManager::SpecialCaseRenderQueueMode

Enumeration of the possible modes allowed for processing the special case render queue list.

See also
  SceneManager::setSpecialCaseRenderQueueMode

Enumerator
SCRQM_INCLUDE | Render only the queues in the special case list.
SCRQM_EXCLUDE | Render all except the queues in the special case list.

## Constructor & Destructor Documentation

## ◆ SceneManager()

Ogre::SceneManager::SceneManager | ( | const String & | instanceName | ) |

Constructor.

Referenced by Ogre::SceneManager::Listener::postFindVisibleObjects(), Ogre::SceneManager::Listener::postUpdateSceneGraph(), Ogre::SceneManager::Listener::preFindVisibleObjects(), Ogre::SceneManager::Listener::preUpdateSceneGraph(), and Ogre::SceneManager::Listener::sceneManagerDestroyed().

## ◆ ~SceneManager()

virtual Ogre::SceneManager::~SceneManager | ( |  | ) |
| virtual

Default destructor.

## Member Function Documentation

## ◆ _pauseRendering()

RenderContext * Ogre::SceneManager::_pauseRendering | ( |  | ) |

Pause rendering of the frame.

This has to be called when inside a renderScene call (Usually using a listener of some sort)

## ◆ _resumeRendering()

void Ogre::SceneManager::_resumeRendering | ( | RenderContext * | context | ) |

Resume rendering of the frame.

This has to be called after a _pauseRendering call

Parameters

  context | The rendring context, as returned by the _pauseRendering call

## ◆ usePerRenderableLights()

void Ogre::SceneManager::usePerRenderableLights | ( | bool | enabled | ) |
| inlinestatic

Toggle sorting of lights for each renderable.

By default, lights are sorted for each renderable based on their distance. This allows having more than 8 lights affecting the scene. However, the sorting is expensive and prevents the use of more efficient algorithms.

Disabling this option will make the lights be sorted only once per frame. Also disables per-renderable light masks.

## ◆ hasPerRenderableLights()

bool Ogre::SceneManager::hasPerRenderableLights | ( |  | ) |
| inlinestatic

## ◆ OGRE_MUTEX()

Ogre::SceneManager::OGRE_MUTEX | ( | sceneGraphMutex |  | ) |

Mutex to protect the scene graph from simultaneous access from multiple threads.

If you are updating the scene in a separate thread from the rendering thread, then you should lock this mutex before making any changes to the scene graph - that means creating, modifying or deleting a scene node, or attaching / detaching objects. It is your responsibility to take out this lock, the detail methods on the nodes will not do it for you (for the reasons discussed below).

  Note that locking this mutex will prevent the scene being rendered until it is unlocked again. Therefore you should do this sparingly. Try to create any objects you need separately and fully prepare them before doing all your scene graph work in one go, thus keeping this lock for the shortest time possible.

Note
  A single global lock is used rather than a per-node lock since it keeps the number of locks required during rendering down to a minimum. Obtaining a lock, even if there is no contention, is not free so for performance it is good to do it as little as possible. Since modifying the scene in a separate thread is a fairly rare occurrence (relative to rendering), it is better to keep the locking required during rendering lower than to make update locks more granular.

## ◆ getName()

const String & Ogre::SceneManager::getName | ( | void |  | ) | const
| inline

Return the instance name of this SceneManager.

## ◆ getTypeName()

virtual const String & Ogre::SceneManager::getTypeName | ( | void |  | ) | const
| pure virtual

Retrieve the type name of this scene manager.

This method has to be implemented by subclasses. It should return the type name of this SceneManager which agrees with the type name of the SceneManagerFactory which created it.

Implemented in Ogre::BspSceneManager, Ogre::OctreeSceneManager, and Ogre::PCZSceneManager.

## ◆ createCamera()

virtual Camera * Ogre::SceneManager::createCamera | ( | const String & | name | ) |
| virtual

Creates a camera to be managed by this scene manager.

This camera must be added to the scene at a later time using the attachObject method of the SceneNode class.

Parameters

  name | Name to give the new camera.

Reimplemented in Ogre::OctreeSceneManager, and Ogre::PCZSceneManager.

## ◆ getCamera()

Camera * Ogre::SceneManager::getCamera | ( | const String & | name | ) | const

Retrieves a pointer to the named camera.

Note
  Throws an exception if the named instance does not exist

## ◆ hasCamera()

bool Ogre::SceneManager::hasCamera | ( | const String & | name | ) | const

Returns whether a camera with the given name exists.

## ◆ destroyCamera() [1/2]

void Ogre::SceneManager::destroyCamera | ( | Camera * | cam | ) |

Removes a camera from the scene.

This method removes a previously added camera from the scene. The camera is deleted so the caller must ensure no references to it's previous instance (e.g. in a SceneNode) are used.

Parameters

  cam | Pointer to the camera to remove

## ◆ destroyCamera() [2/2]

void Ogre::SceneManager::destroyCamera | ( | const String & | name | ) |

Removes a camera from the scene.

This method removes an camera from the scene based on the camera's name rather than a pointer.

## ◆ destroyAllCameras()

void Ogre::SceneManager::destroyAllCameras | ( | void |  | ) |

Removes (and destroys) all cameras from the scene.

Some cameras are internal created to dealing with texture shadow, their aren't supposed to destroy outside. So, while you are using texture shadow, don't call this method, or you can set the shadow technique other than texture-based, which will destroy all internal created shadow cameras and textures.

## ◆ setCameraRelativeRendering()

void Ogre::SceneManager::setCameraRelativeRendering | ( | bool | rel | ) |
| inline

Set whether to use camera-relative coordinates when rendering, ie to always place the camera at the origin and move the world around it.

This is a technique to alleviate some of the precision issues associated with rendering far from the origin, where single-precision floats as used in most GPUs begin to lose their precision. Instead of including the camera translation in the view matrix, it only includes the rotation, and the world matrices of objects must be expressed relative to this.

Note
  If you need this option, you will probably also need to enable double-precision mode in Ogre (OGRE_DOUBLE_PRECISION), since even though this will alleviate the rendering precision, the source camera and object positions will still suffer from precision issues leading to jerky movement.

## ◆ getCameraRelativeRendering()

bool Ogre::SceneManager::getCameraRelativeRendering | ( |  | ) | const
| inline

Get whether to use camera-relative coordinates when rendering, ie to always place the camera at the origin and move the world around it.

## ◆ getCameraIterator()

CameraIterator Ogre::SceneManager::getCameraIterator | ( | void |  | ) |
| inline

Returns a specialised MapIterator over all cameras in the scene.

Deprecated
  use getCameras()

## ◆ getCameras()

const CameraList & Ogre::SceneManager::getCameras | ( |  | ) | const
| inline

Returns a const version of the camera list.

## ◆ createLight() [1/4]

virtual Light * Ogre::SceneManager::createLight | ( | const String & | name | ) |
| virtual

Creates a light for use in the scene.

Lights can either be in a fixed position and independent of the scene graph, or they can be attached to SceneNodes so they derive their position from the parent node. Either way, they are created using this method so that the SceneManager manages their existence.

Parameters

  name | The name of the new light, to identify it later.

Reimplemented in Ogre::PCZSceneManager.

Referenced by createLight(), and createLight().

## ◆ createLight() [2/4]

Light * Ogre::SceneManager::createLight | ( | const String & | name,
|  | Light::LightTypes | type )
| inline

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

References createLight().

## ◆ createLight() [3/4]

virtual Light * Ogre::SceneManager::createLight | ( |  | ) |
| virtual

Creates a light with a generated name.

## ◆ createLight() [4/4]

Light * Ogre::SceneManager::createLight | ( | Light::LightTypes | type | ) |
| inline

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

References createLight().

## ◆ getLight()

virtual Light * Ogre::SceneManager::getLight | ( | const String & | name | ) | const
| virtual

Get a reference to a previously created object instance.

Note
  Throws an exception if the named instance does not exist

Reimplemented in Ogre::PCZSceneManager.

## ◆ hasLight()

virtual bool Ogre::SceneManager::hasLight | ( | const String & | name | ) | const
| inlinevirtual

Returns whether a object instance with the given name exists.

Reimplemented in Ogre::PCZSceneManager.

References hasMovableObject(), and Ogre::MOT_LIGHT.

## ◆ getLightClippingPlanes()

const PlaneList & Ogre::SceneManager::getLightClippingPlanes | ( | Light * | l | ) |

Retrieve a set of clipping planes for a given light.

## ◆ getLightScissorRect()

const RealRect & Ogre::SceneManager::getLightScissorRect | ( | Light * | l,
|  | const Camera * | cam )

Retrieve a scissor rectangle for a given light and camera.

## ◆ invalidatePerFrameScissorRectCache()

virtual void Ogre::SceneManager::invalidatePerFrameScissorRectCache | ( |  | ) |
| virtual

Scissor rects are cached during frame, and this cache should be explicitly invalidated if several renders are done during one frame using different projections matrices, for example for tiled, stereo or multiview orthographic projection rendering.

## ◆ destroyLight() [1/2]

virtual void Ogre::SceneManager::destroyLight | ( | const String & | name | ) |
| inlinevirtual

Removes the light from the scene and destroys it.

Any pointers held to this light after calling this method will be invalid.

Reimplemented in Ogre::PCZSceneManager.

References destroyMovableObject(), and Ogre::MOT_LIGHT.

## ◆ destroyLight() [2/2]

void Ogre::SceneManager::destroyLight | ( | Light * | light | ) |
| inline

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

References destroyMovableObject().

## ◆ destroyAllLights()

virtual void Ogre::SceneManager::destroyAllLights | ( | void |  | ) |
| inlinevirtual

Removes and destroys all lights in the scene.

Reimplemented in Ogre::PCZSceneManager.

References destroyAllMovableObjectsByType(), and Ogre::MOT_LIGHT.

## ◆ _notifyLightsDirty()

void Ogre::SceneManager::_notifyLightsDirty | ( | void |  | ) |

Advanced method to increase the lights dirty counter due to lights having changed.

The SceneManager tracks the list of lights affecting the current frustum, and if changes are detected (including changes to the light list itself or to a light's position or attenuation range) then it increases the lights dirty counter.

  You could call this method to force all the objects in the scene to re-populate their light list, but doing so may harm performance so should be avoided if possible.

## ◆ _getLightsDirtyCounter()

ulong Ogre::SceneManager::_getLightsDirtyCounter | ( | void |  | ) | const
| inline

Advanced method to gets the lights dirty counter.

The SceneManager tracks the list of lights affecting the current frustum, and if changes are detected (including changes to the light list itself or to a light's position or attenuation range) then it increases the lights dirty counter.

## ◆ _getLightsAffectingFrustum()

const LightList & Ogre::SceneManager::_getLightsAffectingFrustum | ( | void |  | ) | const

Get the list of lights which could be affecting the frustum.

This returns a cached light list which is populated when rendering the scene.

## ◆ _populateLightList() [1/2]

void Ogre::SceneManager::_populateLightList | ( | const Vector3 & | position,
|  | Real | radius,
|  | LightList & | destList,
|  | uint32 | lightMask = 0xFFFFFFFF )

Populate a light list with an ordered set of the lights which are closest to the position specified.

Note
  since directional lights have no position, they are always considered closer than any point lights and as such will always take precedence.

The returned lights are those in the cached list of lights (i.e. those returned by SceneManager::_getLightsAffectingFrustum) sorted by distance.

  The number of items in the list may exceed the maximum number of lights supported by the renderer, but the extraneous ones will never be used. In fact the limit will be imposed by Pass::getMaxSimultaneousLights.

Parameters

  position | The position at which to evaluate the list of lights
  radius | The bounding radius to test
  destList | List to be populated with ordered set of lights; will be cleared by this method before population.
  lightMask | The mask with which to include / exclude lights

Referenced by _populateLightList().

## ◆ _populateLightList() [2/2]

void Ogre::SceneManager::_populateLightList | ( | const SceneNode * | sn,
|  | Real | radius,
|  | LightList & | destList,
|  | uint32 | lightMask = 0xFFFFFFFF )
| inline

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

References Ogre::Node::_getDerivedPosition(), and _populateLightList().

## ◆ createSceneNode() [1/2]

SceneNode * Ogre::SceneManager::createSceneNode | ( | void |  | ) |

Creates an instance of a SceneNode.

Note
  this does not add the SceneNode to the scene hierarchy.

This method is for convenience, since it allows an instance to be created for which the SceneManager is responsible for allocating and releasing memory, which is convenient in complex scenes.

  To include the returned SceneNode in the scene, use the SceneNode::addChild method of the node which is to be it's parent.

  Note that this method takes no parameters, and the node created is unnamed. If you wish to create a node with a specific name, call the alternative method which takes a name parameter.

## ◆ createSceneNode() [2/2]

SceneNode * Ogre::SceneManager::createSceneNode | ( | const String & | name | ) |

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

## ◆ destroySceneNode() [1/2]

virtual void Ogre::SceneManager::destroySceneNode | ( | SceneNode * | sn | ) |
| virtual

Destroys a SceneNode.

This allows you to physically delete an individual SceneNode if you want to.

Note
  it is not necessary to call this method when destroying a scene. it's better to allow SceneManager to delete the nodes when the scene is cleared.

Reimplemented in Ogre::OctreeSceneManager, and Ogre::PCZSceneManager.

## ◆ destroySceneNode() [2/2]

void Ogre::SceneManager::destroySceneNode | ( | const String & | name | ) |

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

## ◆ getRootSceneNode()

SceneNode * Ogre::SceneManager::getRootSceneNode | ( | void |  | ) |

Gets the SceneNode at the root of the scene hierarchy.

The entire scene is held as a hierarchy of nodes, which allows things like relative transforms, general changes in rendering state etc (See the SceneNode class for more info). In this basic SceneManager class, the application using Ogre is free to structure this hierarchy however it likes, since it has no real significance apart from making transforms relative to each node (more specialised subclasses will provide utility methods for building specific node structures e.g. loading a BSP tree).

  However, in all cases there is only ever one root node of the hierarchy, and this method returns a pointer to it.

## ◆ getSceneNode()

SceneNode * Ogre::SceneManager::getSceneNode | ( | const String & | name,
|  | bool | throwExceptionIfNotFound = true ) const

Retrieves a named SceneNode from the scene graph.

If you chose to name a SceneNode as you created it, you can look it up wherever it is in the scene graph using this method.

Parameters

  name |
  throwExceptionIfNotFound | Throws an exception if the named instance does not exist

Referenced by hasSceneNode().

## ◆ hasSceneNode()

bool Ogre::SceneManager::hasSceneNode | ( | const String & | name | ) | const
| inline

Returns whether a scene node with the given name exists.

References getSceneNode().

## ◆ setDisplaySceneNodes()

void Ogre::SceneManager::setDisplaySceneNodes | ( | bool | display | ) |

Tells the SceneManager whether it should render the SceneNodes which make up the scene as well as the objects in the scene.

This method is mainly for debugging purposes. If you set this to 'true', each node will be rendered as a set of 3 axes to allow you to easily see the orientation of the nodes.

## ◆ getDisplaySceneNodes()

bool Ogre::SceneManager::getDisplaySceneNodes | ( | void |  | ) | const
| inline

Returns true if all scene nodes axis are to be displayed.

## ◆ showBoundingBoxes()

void Ogre::SceneManager::showBoundingBoxes | ( | bool | bShow | ) |

Allows all bounding boxes of scene nodes to be displayed.

## ◆ getShowBoundingBoxes()

bool Ogre::SceneManager::getShowBoundingBoxes | ( |  | ) | const

Returns if all bounding boxes of scene nodes are to be displayed.

## ◆ getDebugDrawer()

DebugDrawer * Ogre::SceneManager::getDebugDrawer | ( |  | ) | const
| inline

## ◆ createEntity() [1/4]

Entity * Ogre::SceneManager::createEntity | ( | const String & | entityName,
|  | const String & | meshName,
|  | const String & | groupName = ResourceGroupManager::AUTODETECT_RESOURCE_GROUP_NAME )

Create an Entity (instance of a discrete mesh).

Parameters

  entityName | The name to be given to the entity (must be unique).
  meshName | The name of the Mesh it is to be based on (e.g. 'knot.oof'). The mesh will be loaded if it is not already.
  groupName | The resource name where the mesh lives

References Ogre::ResourceGroupManager::AUTODETECT_RESOURCE_GROUP_NAME.

## ◆ createEntity() [2/4]

Entity * Ogre::SceneManager::createEntity | ( | const String & | entityName,
|  | const MeshPtr & | pMesh )

Create an Entity (instance of a discrete mesh).

Parameters

  entityName | The name to be given to the entity (must be unique).
  pMesh | The pointer to the Mesh it is to be based on.

## ◆ createEntity() [3/4]

Entity * Ogre::SceneManager::createEntity | ( | const String & | meshName | ) |

Create an Entity (instance of a discrete mesh) with an autogenerated name.

Parameters

  meshName | The name of the Mesh it is to be based on (e.g. 'knot.oof'). The mesh will be loaded if it is not already.

## ◆ createEntity() [4/4]

Entity * Ogre::SceneManager::createEntity | ( | const MeshPtr & | pMesh | ) |

Create an Entity (instance of a discrete mesh) with an autogenerated name.

Parameters

  pMesh | The pointer to the Mesh it is to be based on.

## ◆ getEntity()

Entity * Ogre::SceneManager::getEntity | ( | const String & | name | ) | const

Get a reference to a previously created object instance.

Note
  Throws an exception if the named instance does not exist

## ◆ hasEntity()

bool Ogre::SceneManager::hasEntity | ( | const String & | name | ) | const
| inline

Returns whether a object instance with the given name exists.

References hasMovableObject(), and Ogre::MOT_ENTITY.

## ◆ destroyEntity() [1/2]

void Ogre::SceneManager::destroyEntity | ( | MovableObject * | ent | ) |
| inline

Removes & destroys an Entity from the SceneManager.

References destroyMovableObject().

## ◆ destroyEntity() [2/2]

void Ogre::SceneManager::destroyEntity | ( | const String & | name | ) |
| inline

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

References destroyMovableObject(), and Ogre::MOT_ENTITY.

## ◆ destroyAllEntities()

void Ogre::SceneManager::destroyAllEntities | ( | void |  | ) |
| inline

Removes & destroys all Entities.

References destroyAllMovableObjectsByType(), and Ogre::MOT_ENTITY.

## ◆ createManualObject() [1/2]

ManualObject * Ogre::SceneManager::createManualObject | ( | const String & | name | ) |

Create a ManualObject, an object which you populate with geometry manually through a GL immediate-mode style interface.

Parameters

  name | The name to be given to the object (must be unique).

## ◆ createManualObject() [2/2]

ManualObject * Ogre::SceneManager::createManualObject | ( |  | ) |

Create a ManualObject, an object which you populate with geometry manually through a GL immediate-mode style interface, generating the name.

## ◆ getManualObject()

ManualObject * Ogre::SceneManager::getManualObject | ( | const String & | name | ) | const

Get a reference to a previously created object instance.

Note
  Throws an exception if the named instance does not exist

## ◆ hasManualObject()

bool Ogre::SceneManager::hasManualObject | ( | const String & | name | ) | const
| inline

Returns whether a object instance with the given name exists.

References hasMovableObject(), and Ogre::MOT_MANUAL_OBJECT.

## ◆ destroyManualObject() [1/2]

void Ogre::SceneManager::destroyManualObject | ( | MovableObject * | obj | ) |
| inline

Removes & destroys a ManualObject from the SceneManager.

References destroyMovableObject().

## ◆ destroyManualObject() [2/2]

void Ogre::SceneManager::destroyManualObject | ( | const String & | name | ) |
| inline

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

References destroyMovableObject(), and Ogre::MOT_MANUAL_OBJECT.

## ◆ destroyAllManualObjects()

void Ogre::SceneManager::destroyAllManualObjects | ( | void |  | ) |
| inline

Removes & destroys all ManualObjects from the SceneManager.

References destroyAllMovableObjectsByType(), and Ogre::MOT_MANUAL_OBJECT.

## ◆ createScreenSpaceRect() [1/2]

Rectangle2D * Ogre::SceneManager::createScreenSpaceRect | ( | const String & | name,
|  | bool | includeTextureCoords = false )

Creates a Rectangle2D that can be displayed for screen space effects or showing a basic GUI.

Parameters

  name | The name to be given to the object (must be unique).
  includeTextureCoords | whether to create texture coordinates

## ◆ createScreenSpaceRect() [2/2]

Rectangle2D * Ogre::SceneManager::createScreenSpaceRect | ( | bool | includeTextureCoords = false | ) |

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

## ◆ hasScreenSpaceRect()

bool Ogre::SceneManager::hasScreenSpaceRect | ( | const String & | name | ) | const
| inline

Returns whether a object instance with the given name exists.

References hasMovableObject(), and Ogre::MOT_RECTANGLE2D.

## ◆ getScreenSpaceRect()

Rectangle2D * Ogre::SceneManager::getScreenSpaceRect | ( | const String & | name | ) | const

Get a reference to a previously created object instance.

Note
  Throws an exception if the named instance does not exist

## ◆ createBillboardChain() [1/2]

BillboardChain * Ogre::SceneManager::createBillboardChain | ( | const String & | name | ) |

Create a BillboardChain, an object which you can use to render a linked chain of billboards.

Parameters

  name | The name to be given to the object (must be unique).

## ◆ createBillboardChain() [2/2]

BillboardChain * Ogre::SceneManager::createBillboardChain | ( |  | ) |

Create a BillboardChain, an object which you can use to render a linked chain of billboards, with a generated name.

## ◆ getBillboardChain()

BillboardChain * Ogre::SceneManager::getBillboardChain | ( | const String & | name | ) | const

Get a reference to a previously created object instance.

Note
  Throws an exception if the named instance does not exist

## ◆ hasBillboardChain()

bool Ogre::SceneManager::hasBillboardChain | ( | const String & | name | ) | const
| inline

Returns whether a object instance with the given name exists.

References hasMovableObject(), and Ogre::MOT_BILLBOARD_CHAIN.

## ◆ destroyBillboardChain() [1/2]

void Ogre::SceneManager::destroyBillboardChain | ( | MovableObject * | obj | ) |
| inline

Removes & destroys a BillboardChain from the SceneManager.

References destroyMovableObject().

## ◆ destroyBillboardChain() [2/2]

void Ogre::SceneManager::destroyBillboardChain | ( | const String & | name | ) |
| inline

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

References destroyMovableObject(), and Ogre::MOT_BILLBOARD_CHAIN.

## ◆ destroyAllBillboardChains()

void Ogre::SceneManager::destroyAllBillboardChains | ( | void |  | ) |
| inline

Removes & destroys all BillboardChains from the SceneManager.

References destroyAllMovableObjectsByType(), and Ogre::MOT_BILLBOARD_CHAIN.

## ◆ createRibbonTrail() [1/2]

RibbonTrail * Ogre::SceneManager::createRibbonTrail | ( | const String & | name | ) |

Create a RibbonTrail, an object which you can use to render a linked chain of billboards which follows one or more nodes.

Parameters

  name | The name to be given to the object (must be unique).

## ◆ createRibbonTrail() [2/2]

RibbonTrail * Ogre::SceneManager::createRibbonTrail | ( |  | ) |

Create a RibbonTrail, an object which you can use to render a linked chain of billboards which follows one or more nodes, generating the name.

## ◆ getRibbonTrail()

RibbonTrail * Ogre::SceneManager::getRibbonTrail | ( | const String & | name | ) | const

Get a reference to a previously created object instance.

Note
  Throws an exception if the named instance does not exist

## ◆ hasRibbonTrail()

bool Ogre::SceneManager::hasRibbonTrail | ( | const String & | name | ) | const
| inline

Returns whether a object instance with the given name exists.

References hasMovableObject(), and Ogre::MOT_RIBBON_TRAIL.

## ◆ destroyRibbonTrail() [1/2]

void Ogre::SceneManager::destroyRibbonTrail | ( | MovableObject * | obj | ) |
| inline

Removes & destroys a RibbonTrail from the SceneManager.

References destroyMovableObject().

## ◆ destroyRibbonTrail() [2/2]

void Ogre::SceneManager::destroyRibbonTrail | ( | const String & | name | ) |
| inline

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

References destroyMovableObject(), and Ogre::MOT_RIBBON_TRAIL.

## ◆ destroyAllRibbonTrails()

void Ogre::SceneManager::destroyAllRibbonTrails | ( | void |  | ) |
| inline

Removes & destroys all RibbonTrails from the SceneManager.

References destroyAllMovableObjectsByType(), and Ogre::MOT_RIBBON_TRAIL.

## ◆ createParticleSystem() [1/3]

ParticleSystem * Ogre::SceneManager::createParticleSystem | ( | const String & | name,
|  | const String & | templateName )

Creates a particle system based on a template.

This method creates a new ParticleSystem instance based on the named template (defined through ParticleSystemManager::createTemplate) and returns a pointer to the caller. The caller should not delete this object, it will be freed at system shutdown, or can be released earlier using the destroyParticleSystem method.

  Each system created from a template takes the template's settings at the time of creation, but is completely separate from the template from there on.

  Creating a particle system does not make it a part of the scene. As with other MovableObject subclasses, a ParticleSystem is not rendered until it is attached to a SceneNode.

  This is probably the more useful particle system creation method since it does not require manual setup of the system.

Note
  the initial quota is based on the template but may be changed later.

Parameters

  name | The name to give the new particle system instance.
  templateName | The name of the template to base the new instance on.

## ◆ createParticleSystem() [2/3]

ParticleSystem * Ogre::SceneManager::createParticleSystem | ( | const String & | name,
|  | size_t | quota = 500,
|  | const String & | resourceGroup = ResourceGroupManager::DEFAULT_RESOURCE_GROUP_NAME )

Create a blank particle system.

This method creates a new, blank ParticleSystem instance and returns a pointer to it. The caller should not delete this object, it will be freed at system shutdown, or can be released earlier using the destroyParticleSystem method.

  The instance returned from this method won't actually do anything because on creation a particle system has no emitters. The caller should manipulate the instance through it's ParticleSystem methods to actually create a real particle effect.

  Creating a particle system does not make it a part of the scene. As with other MovableObject subclasses, a ParticleSystem is not rendered until it is attached to a SceneNode.

Parameters

  name | The name to give the ParticleSystem.
  quota | The maximum number of particles to allow in this system.
  resourceGroup | The resource group which will be used to load dependent resources

References Ogre::ResourceGroupManager::DEFAULT_RESOURCE_GROUP_NAME.

## ◆ createParticleSystem() [3/3]

ParticleSystem * Ogre::SceneManager::createParticleSystem | ( | size_t | quota = 500,
|  | const String & | resourceGroup = ResourceGroupManager::DEFAULT_RESOURCE_GROUP_NAME )

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

References Ogre::ResourceGroupManager::DEFAULT_RESOURCE_GROUP_NAME.

## ◆ getParticleSystem()

ParticleSystem * Ogre::SceneManager::getParticleSystem | ( | const String & | name | ) | const

Get a reference to a previously created object instance.

Note
  Throws an exception if the named instance does not exist

## ◆ hasParticleSystem()

bool Ogre::SceneManager::hasParticleSystem | ( | const String & | name | ) | const
| inline

Returns whether a object instance with the given name exists.

References hasMovableObject(), and Ogre::MOT_PARTICLE_SYSTEM.

## ◆ destroyParticleSystem() [1/2]

void Ogre::SceneManager::destroyParticleSystem | ( | MovableObject * | obj | ) |
| inline

Removes & destroys a ParticleSystem from the SceneManager.

References destroyMovableObject().

## ◆ destroyParticleSystem() [2/2]

void Ogre::SceneManager::destroyParticleSystem | ( | const String & | name | ) |
| inline

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

References destroyMovableObject(), and Ogre::MOT_PARTICLE_SYSTEM.

## ◆ destroyAllParticleSystems()

void Ogre::SceneManager::destroyAllParticleSystems | ( | void |  | ) |
| inline

Removes & destroys all ParticleSystems from the SceneManager.

References destroyAllMovableObjectsByType(), and Ogre::MOT_PARTICLE_SYSTEM.

## ◆ clearScene()

virtual void Ogre::SceneManager::clearScene | ( | void |  | ) |
| virtual

Empties the entire scene, including all SceneNodes, Entities, Lights, BillboardSets etc.

Cameras are not deleted at this stage since they are still referenced by viewports, which are not destroyed during this process.

Reimplemented in Ogre::OctreeSceneManager, and Ogre::PCZSceneManager.

## ◆ setAmbientLight()

void Ogre::SceneManager::setAmbientLight | ( | const ColourValue & | colour | ) |

Sets the ambient light level to be used for the scene.

This sets the colour and intensity of the ambient light in the scene, i.e. the light which is 'sourceless' and illuminates all objects equally. The colour of an object is affected by a combination of the light in the scene, and the amount of light that object reflects (in this case based on the Material::ambient property).

By default the ambient light in the scene is ColourValue::Black, i.e. no ambient light. This means that any objects rendered with a Material which has lighting enabled (see Material::setLightingEnabled) will not be visible unless you have some dynamic lights in your scene.

## ◆ getAmbientLight()

const ColourValue & Ogre::SceneManager::getAmbientLight | ( | void |  | ) | const

Returns the ambient light level to be used for the scene.

## ◆ setWorldGeometry() [1/2]

virtual void Ogre::SceneManager::setWorldGeometry | ( | const String & | filename | ) |
| virtual

Sets the source of the 'world' geometry, i.e.

the large, mainly static geometry making up the world e.g. rooms, landscape etc.

Depending on the type of SceneManager (subclasses will be specialised for particular world geometry types) you have requested via the Root or SceneManagerEnumerator classes, you can pass a filename to this method and it will attempt to load the world-level geometry for use. If you try to load an inappropriate type of world data an exception will be thrown. The default SceneManager cannot handle any sort of world geometry and so will always throw an exception. However subclasses like BspSceneManager can load particular types of world geometry e.g. "q3dm1.bsp".

Reimplemented in Ogre::BspSceneManager.

## ◆ setWorldGeometry() [2/2]

virtual void Ogre::SceneManager::setWorldGeometry | ( | DataStreamPtr & | stream,
|  | const String & | typeName = BLANKSTRING )
| virtual

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

Parameters

  stream | Data stream containing data to load
  typeName | String identifying the type of world geometry contained in the stream - not required if this manager only supports one type of world geometry.

Reimplemented in Ogre::BspSceneManager.

References Ogre::BLANKSTRING.

## ◆ estimateWorldGeometry() [1/2]

virtual size_t Ogre::SceneManager::estimateWorldGeometry | ( | const String & | filename | ) |
| inlinevirtual

Estimate the number of loading stages required to load the named world geometry.

This method should be overridden by SceneManagers that provide custom world geometry that can take some time to load. They should return from this method a count of the number of stages of progress they can report on whilst loading. During real loading (setWorldGeometry), they should call ResourceGroupManager::_notifyCustomStage* exactly that number of times when loading the geometry for real.

Note
  The default is to return 0, ie to not report progress.

Reimplemented in Ogre::BspSceneManager.

## ◆ estimateWorldGeometry() [2/2]

virtual size_t Ogre::SceneManager::estimateWorldGeometry | ( | DataStreamPtr & | stream,
|  | const String & | typeName = BLANKSTRING )
| inlinevirtual

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

Parameters

  stream | Data stream containing data to load
  typeName | String identifying the type of world geometry contained in the stream - not required if this manager only supports one type of world geometry.

Reimplemented in Ogre::BspSceneManager.

References Ogre::BLANKSTRING.

## ◆ getSuggestedViewpoint()

virtual ViewPoint Ogre::SceneManager::getSuggestedViewpoint | ( | bool | random = false | ) |
| virtual

Asks the SceneManager to provide a suggested viewpoint from which the scene should be viewed.

Typically this method returns the origin unless a) world geometry has been loaded using SceneManager::setWorldGeometry and b) that world geometry has suggested 'start' points. If there is more than one viewpoint which the scene manager can suggest, it will always suggest the first one unless the random parameter is true.

Parameters

  random | If true, and there is more than one possible suggestion, a random one will be used. If false the same one will always be suggested.

Returns
  On success, true is returned.

  On failure, false is returned.

Reimplemented in Ogre::BspSceneManager.

## ◆ setOption()

virtual bool Ogre::SceneManager::setOption | ( | const String & | strKey,
|  | const void * | pValue )
| inlinevirtual

Method for setting a specific option of the Scene Manager.

These options are usually specific for a certain implementation of the Scene Manager class, and may (and probably will) not exist across different implementations.

Parameters

  strKey | The name of the option to set
  pValue | A pointer to the value - the size should be calculated by the scene manager based on the key

Returns
  On success, true is returned.

  On failure, false is returned.

Reimplemented in Ogre::OctreeSceneManager, and Ogre::PCZSceneManager.

## ◆ getOption()

virtual bool Ogre::SceneManager::getOption | ( | const String & | strKey,
|  | void * | pDestValue )
| inlinevirtual

Method for getting the value of an implementation-specific Scene Manager option.

Parameters

  strKey | The name of the option
  pDestValue | A pointer to a memory location where the value will be copied. Currently, the memory will be allocated by the scene manager, but this may change

Returns
  On success, true is returned and pDestValue points to the value of the given option.

  On failure, false is returned and pDestValue is set to NULL.

Reimplemented in Ogre::OctreeSceneManager, and Ogre::PCZSceneManager.

## ◆ hasOption()

virtual bool Ogre::SceneManager::hasOption | ( | const String & | strKey | ) | const
| inlinevirtual

Method for verifying whether the scene manager has an implementation-specific option.

Parameters

  strKey | The name of the option to check for.

Returns
  If the scene manager contains the given option, true is returned.

If it does not, false is returned.

## ◆ getOptionValues()

virtual bool Ogre::SceneManager::getOptionValues | ( | const String & | strKey,
|  | StringVector & | refValueList )
| inlinevirtual

Method for getting all possible values for a specific option.

When this list is too large (i.e. the option expects, for example, a float), the return value will be true, but the list will contain just one element whose size will be set to 0. Otherwise, the list will be filled with all the possible values the option can accept.

Parameters

  strKey | The name of the option to get the values for.
  refValueList | A reference to a list that will be filled with the available values.

Returns
  On success (the option exists), true is returned.

  On failure, false is returned.

Reimplemented in Ogre::OctreeSceneManager, and Ogre::PCZSceneManager.

## ◆ getOptionKeys()

virtual bool Ogre::SceneManager::getOptionKeys | ( | StringVector & | refKeys | ) |
| inlinevirtual

Method for getting all the implementation-specific options of the scene manager.

Parameters

  refKeys | A reference to a list that will be filled with all the available options.

Returns
  On success, true is returned. On failure, false is returned.

Reimplemented in Ogre::OctreeSceneManager, and Ogre::PCZSceneManager.

## ◆ _updateSceneGraph()

virtual void Ogre::SceneManager::_updateSceneGraph | ( | Camera * | cam | ) |
| virtual

Internal method for updating the scene graph ie the tree of SceneNode instances managed by this class.

This must be done before issuing objects to the rendering pipeline, since derived transformations from parent nodes are not updated until required. This SceneManager is a basic implementation which simply updates all nodes from the root. This ensures the scene is up to date but requires all the nodes to be updated even if they are not visible. Subclasses could trim this such that only potentially visible nodes are updated.

Reimplemented in Ogre::OctreeSceneManager, and Ogre::PCZSceneManager.

## ◆ _findVisibleObjects()

virtual void Ogre::SceneManager::_findVisibleObjects | ( | Camera * | cam,
|  | VisibleObjectsBoundsInfo * | visibleBounds,
|  | bool | onlyShadowCasters )
| virtual

Internal method which parses the scene to find visible objects to render.

If you're implementing a custom scene manager, this is the most important method to override since it's here you can apply your custom world partitioning scheme. Once you have added the appropriate objects to the render queue, you can let the default SceneManager objects _renderVisibleObjects handle the actual rendering of the objects you pick.

  Any visible objects will be added to a rendering queue, which is indexed by material in order to ensure objects with the same material are rendered together to minimise render state changes.

Reimplemented in Ogre::BspSceneManager, Ogre::OctreeSceneManager, and Ogre::PCZSceneManager.

## ◆ _issueRenderOp()

void Ogre::SceneManager::_issueRenderOp | ( | Renderable * | rend,
|  | const Pass * | pass )

Internal method for issuing the render operation.

## ◆ _renderVisibleObjects()

void Ogre::SceneManager::_renderVisibleObjects | ( | void |  | ) |

Sends visible objects found in _findVisibleObjects to the rendering engine.

## ◆ _renderScene()

virtual void Ogre::SceneManager::_renderScene | ( | Camera * | camera,
|  | Viewport * | vp,
|  | bool | includeOverlays = true )
| virtual

Prompts the class to send its contents to the renderer.

This method prompts the scene manager to send the contents of the scene it manages to the rendering pipeline, possibly preceded by some sorting, culling or other scene management tasks. Note that this method is not normally called directly by the user application; it is called automatically by the Ogre rendering loop.

Parameters

  camera | Pointer to a camera from whose viewpoint the scene is to be rendered.
  vp | The target viewport
  includeOverlays | unused

Reimplemented in Ogre::PCZSceneManager.

## ◆ _setDestinationRenderSystem()

void Ogre::SceneManager::_setDestinationRenderSystem | ( | RenderSystem * | sys | ) |

Notifies the scene manager of its destination render system.

Called automatically by RenderSystem::addSceneManager this method simply notifies the manager of the render system to which its output must be directed.

Parameters

  sys | Pointer to the RenderSystem subclass to be used as a render target.

## ◆ _releaseManualHardwareResources()

void Ogre::SceneManager::_releaseManualHardwareResources | ( |  | ) |

Notifies the scene manager that hardware resources were lost.

Called automatically by RenderSystem if hardware resources were lost and can not be restored using some internal mechanism. Among affected resources are manual meshes without loaders, manual textures without loaders, ManualObjects, etc.

## ◆ _restoreManualHardwareResources()

void Ogre::SceneManager::_restoreManualHardwareResources | ( |  | ) |

Notifies the scene manager that hardware resources should be restored.

Called automatically by RenderSystem if hardware resources were lost and can not be restored using some internal mechanism. Among affected resources are manual meshes without loaders, manual textures without loaders, ManualObjects, etc.

## ◆ setSkyRenderingEnabled()

void Ogre::SceneManager::setSkyRenderingEnabled | ( | bool | enable | ) |
| inline

Enables / disables a 'sky'.

Referenced by Ogre::PCZSceneManager::enableSky(), setSkyBoxEnabled(), setSkyDomeEnabled(), and setSkyPlaneEnabled().

## ◆ isSkyRenderingEnabled()

bool Ogre::SceneManager::isSkyRenderingEnabled | ( | void |  | ) | const
| inline

Return whether a sky is enabled.

Referenced by isSkyBoxEnabled(), isSkyDomeEnabled(), and isSkyPlaneEnabled().

## ◆ getSkyNode()

SceneNode * Ogre::SceneManager::getSkyNode | ( | void |  | ) | const
| inline

Get the sky node, if enabled.

Referenced by getSkyBoxNode(), getSkyDomeNode(), and getSkyPlaneNode().

## ◆ setSkyPlane()

void Ogre::SceneManager::setSkyPlane | ( | bool | enable,
|  | const Plane & | plane,
|  | const String & | materialName,
|  | Real | scale = 1000,
|  | Real | tiling = 10,
|  | bool | drawFirst = true,
|  | Real | bow = 0,
|  | int | xsegments = 1,
|  | int | ysegments = 1,
|  | const String & | groupName = ResourceGroupManager::AUTODETECT_RESOURCE_GROUP_NAME )

Enables / disables a 'sky plane' i.e.

a plane at constant distance from the camera representing the sky.

You can create sky planes yourself using the standard mesh and entity methods, but this creates a plane which the camera can never get closer or further away from - it moves with the camera. (NB you could create this effect by creating a world plane which was attached to the same SceneNode as the Camera too, but this would only apply to a single camera whereas this plane applies to any camera using this scene manager).

Note
  To apply scaling, scrolls etc to the sky texture(s) you should use the TextureUnitState class methods.

Parameters

  enable | True to enable the plane, false to disable it
  plane | Details of the plane, i.e. it's normal and it's distance from the camera.
  materialName | The name of the material the plane will use
  scale | The scaling applied to the sky plane - higher values mean a bigger sky plane - you may want to tweak this depending on the size of plane.d and the other characteristics of your scene
  tiling | How many times to tile the texture across the sky. Applies to all texture layers. If you need finer control use the TextureUnitState texture coordinate transformation methods.
  drawFirst | If true, the plane is drawn before all other geometry in the scene, without updating the depth buffer. This is the safest rendering method since all other objects will always appear in front of the sky. However this is not the most efficient way if most of the sky is often occluded by other objects. If this is the case, you can set this parameter to false meaning it draws after all other geometry which can be an optimisation - however you must ensure that the plane.d value is large enough that no objects will 'poke through' the sky plane when it is rendered.
  bow | If zero, the plane will be completely flat (like previous versions. If above zero, the plane will be curved, allowing the sky to appear below camera level. Curved sky planes are simular to skydomes, but are more compatible with fog.
  xsegments,ysegments | Determines the number of segments the plane will have to it. This is most important when you are bowing the plane, but may also be useful if you need tessellation on the plane to perform per-vertex effects.
  groupName | The name of the resource group to which to assign the plane mesh.

References Ogre::ResourceGroupManager::AUTODETECT_RESOURCE_GROUP_NAME.

## ◆ _setSkyPlane()

void Ogre::SceneManager::_setSkyPlane | ( | bool | enable,
|  | const Plane & | plane,
|  | const String & | materialName,
|  | Real | scale = 1000,
|  | Real | tiling = 10,
|  | uint8 | renderQueue = RENDER_QUEUE_SKIES_EARLY,
|  | Real | bow = 0,
|  | int | xsegments = 1,
|  | int | ysegments = 1,
|  | const String & | groupName = ResourceGroupManager::AUTODETECT_RESOURCE_GROUP_NAME )

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

References Ogre::ResourceGroupManager::AUTODETECT_RESOURCE_GROUP_NAME, and Ogre::RENDER_QUEUE_SKIES_EARLY.

## ◆ setSkyPlaneEnabled()

void Ogre::SceneManager::setSkyPlaneEnabled | ( | bool | enable | ) |
| inline

Deprecated
  use setSkyRenderingEnabled

References setSkyRenderingEnabled().

## ◆ isSkyPlaneEnabled()

bool Ogre::SceneManager::isSkyPlaneEnabled | ( | void |  | ) | const
| inline

Deprecated
  use isSkyRenderingEnabled

References isSkyRenderingEnabled().

## ◆ getSkyPlaneNode()

SceneNode * Ogre::SceneManager::getSkyPlaneNode | ( | void |  | ) | const
| inline

Deprecated
  use getSkyNode

References getSkyNode().

## ◆ getSkyPlaneGenParameters()

SkyPlaneGenParameters Ogre::SceneManager::getSkyPlaneGenParameters | ( | void |  | ) | const
| inline

Deprecated
  use do not use

## ◆ setSkyBox()

void Ogre::SceneManager::setSkyBox | ( | bool | enable,
|  | const String & | materialName,
|  | Real | distance = 5000,
|  | bool | drawFirst = true,
|  | const Quaternion & | orientation = Quaternion::IDENTITY,
|  | const String & | groupName = ResourceGroupManager::AUTODETECT_RESOURCE_GROUP_NAME )

Enables / disables a 'sky box' i.e.

a 6-sided box at constant distance from the camera representing the sky.

You could create a sky box yourself using the standard mesh and entity methods, but this creates a plane which the camera can never get closer or further away from - it moves with the camera. (NB you could create this effect by creating a world box which was attached to the same SceneNode as the Camera too, but this would only apply to a single camera whereas this skybox applies to any camera using this scene manager).

  The material you use for the skybox can either contain layers which are single textures, or they can be cubic textures, i.e. made up of 6 images, one for each plane of the cube. See the TextureUnitState class for more information.

Parameters

  enable | True to enable the skybox, false to disable it
  materialName | The name of the material the box will use
  distance | Distance in world coordinates from the camera to each plane of the box. The default is normally OK.
  drawFirst | If true, the box is drawn before all other geometry in the scene, without updating the depth buffer. This is the safest rendering method since all other objects will always appear in front of the sky. However this is not the most efficient way if most of the sky is often occluded by other objects. If this is the case, you can set this parameter to false meaning it draws after all other geometry which can be an optimisation - however you must ensure that the distance value is large enough that no objects will 'poke through' the sky box when it is rendered.
  orientation | Optional parameter to specify the orientation of the box. By default the 'top' of the box is deemed to be in the +y direction, and the 'front' at the -z direction. You can use this parameter to rotate the sky if you want.
  groupName | The name of the resource group to which to assign the plane mesh.

References Ogre::ResourceGroupManager::AUTODETECT_RESOURCE_GROUP_NAME, and Ogre::Quaternion::IDENTITY.

## ◆ _setSkyBox()

void Ogre::SceneManager::_setSkyBox | ( | bool | enable,
|  | const String & | materialName,
|  | Real | distance = 5000,
|  | uint8 | renderQueue = RENDER_QUEUE_SKIES_EARLY,
|  | const Quaternion & | orientation = Quaternion::IDENTITY,
|  | const String & | groupName = ResourceGroupManager::AUTODETECT_RESOURCE_GROUP_NAME )

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

References Ogre::ResourceGroupManager::AUTODETECT_RESOURCE_GROUP_NAME, Ogre::Quaternion::IDENTITY, and Ogre::RENDER_QUEUE_SKIES_EARLY.

## ◆ setSkyBoxEnabled()

void Ogre::SceneManager::setSkyBoxEnabled | ( | bool | enable | ) |
| inline

Deprecated
  use setSkyRenderingEnabled

References setSkyRenderingEnabled().

## ◆ isSkyBoxEnabled()

bool Ogre::SceneManager::isSkyBoxEnabled | ( | void |  | ) | const
| inline

Deprecated
  use isSkyRenderingEnabled

References isSkyRenderingEnabled().

## ◆ getSkyBoxNode()

SceneNode * Ogre::SceneManager::getSkyBoxNode | ( | void |  | ) | const
| inline

Deprecated
  use getSkyNode

References getSkyNode().

## ◆ getSkyBoxGenParameters()

SkyBoxGenParameters Ogre::SceneManager::getSkyBoxGenParameters | ( | void |  | ) | const
| inline

Deprecated
  use do not use

## ◆ setSkyDome()

void Ogre::SceneManager::setSkyDome | ( | bool | enable,
|  | const String & | materialName,
|  | Real | curvature = 10,
|  | Real | tiling = 8,
|  | Real | distance = 4000,
|  | bool | drawFirst = true,
|  | const Quaternion & | orientation = Quaternion::IDENTITY,
|  | int | xsegments = 16,
|  | int | ysegments = 16,
|  | int | ysegments_keep = -1,
|  | const String & | groupName = ResourceGroupManager::AUTODETECT_RESOURCE_GROUP_NAME )

Enables / disables a 'sky dome' i.e.

an illusion of a curved sky.

A sky dome is actually formed by 5 sides of a cube, but with texture coordinates generated such that the surface appears curved like a dome. Sky domes are appropriate where you need a realistic looking sky where the scene is not going to be 'fogged', and there is always a 'floor' of some sort to prevent the viewer looking below the horizon (the distortion effect below the horizon can be pretty horrible, and there is never anything directly below the viewer). If you need a complete wrap-around background, use the setSkyBox method instead. You can actually combine a sky box and a sky dome if you want, to give a positional backdrop with an overlaid curved cloud layer.

  Sky domes work well with 2D repeating textures like clouds. You can change the apparent 'curvature' of the sky depending on how your scene is viewed - lower curvatures are better for 'open' scenes like landscapes, whilst higher curvatures are better for say FPS levels where you don't see a lot of the sky at once and the exaggerated curve looks good.

Parameters

  enable | True to enable the skydome, false to disable it
  materialName | The name of the material the dome will use
  curvature | The curvature of the dome. Good values are between 2 and 65. Higher values are more curved leading to a smoother effect, lower values are less curved meaning more distortion at the horizons but a better distance effect.
  tiling | How many times to tile the texture(s) across the dome.
  distance | Distance in world coordinates from the camera to each plane of the box the dome is rendered on. The default is normally OK.
  drawFirst | If true, the dome is drawn before all other geometry in the scene, without updating the depth buffer. This is the safest rendering method since all other objects will always appear in front of the sky. However this is not the most efficient way if most of the sky is often occluded by other objects. If this is the case, you can set this parameter to false meaning it draws after all other geometry which can be an optimisation - however you must ensure that the distance value is large enough that no objects will 'poke through' the sky when it is rendered.
  orientation | Optional parameter to specify the orientation of the dome. By default the 'top' of the dome is deemed to be in the +y direction, and the 'front' at the -z direction. You can use this parameter to rotate the sky if you want.
  groupName | The name of the resource group to which to assign the plane mesh.
  xsegments,ysegments,ysegments_keep | see MeshManager::createCurvedIllusionPlane

References Ogre::ResourceGroupManager::AUTODETECT_RESOURCE_GROUP_NAME, and Ogre::Quaternion::IDENTITY.

## ◆ _setSkyDome()

void Ogre::SceneManager::_setSkyDome | ( | bool | enable,
|  | const String & | materialName,
|  | Real | curvature = 10,
|  | Real | tiling = 8,
|  | Real | distance = 4000,
|  | uint8 | renderQueue = RENDER_QUEUE_SKIES_EARLY,
|  | const Quaternion & | orientation = Quaternion::IDENTITY,
|  | int | xsegments = 16,
|  | int | ysegments = 16,
|  | int | ysegments_keep = -1,
|  | const String & | groupName = ResourceGroupManager::AUTODETECT_RESOURCE_GROUP_NAME )

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

References Ogre::ResourceGroupManager::AUTODETECT_RESOURCE_GROUP_NAME, Ogre::Quaternion::IDENTITY, and Ogre::RENDER_QUEUE_SKIES_EARLY.

## ◆ setSkyDomeEnabled()

void Ogre::SceneManager::setSkyDomeEnabled | ( | bool | enable | ) |
| inline

Deprecated
  use setSkyRenderingEnabled

References setSkyRenderingEnabled().

## ◆ isSkyDomeEnabled()

bool Ogre::SceneManager::isSkyDomeEnabled | ( | void |  | ) | const
| inline

Deprecated
  use isSkyRenderingEnabled

References isSkyRenderingEnabled().

## ◆ getSkyDomeNode()

SceneNode * Ogre::SceneManager::getSkyDomeNode | ( | void |  | ) | const
| inline

Deprecated
  use getSkyNode

References getSkyNode().

## ◆ getSkyDomeGenParameters()

SkyDomeGenParameters Ogre::SceneManager::getSkyDomeGenParameters | ( | void |  | ) | const
| inline

Deprecated
  do not use

## ◆ setFog()

void Ogre::SceneManager::setFog | ( | FogMode | mode = FOG_NONE,
|  | const ColourValue & | colour = ColourValue::White,
|  | Real | expDensity = 0.001f,
|  | Real | linearStart = 0.0f,
|  | Real | linearEnd = 1.0f )

Sets the fogging mode applied to the scene.

This method sets up the scene-wide fogging effect. These settings apply to all geometry rendered, UNLESS the material with which it is rendered has it's own fog settings (see Material::setFog).

Parameters

  mode | Set up the mode of fog as described in the FogMode enum, or set to FOG_NONE to turn off.
  colour | The colour of the fog. Either set this to the same as your viewport background colour, or to blend in with a skydome or skybox.
  expDensity | The density of the fog in FOG_EXP or FOG_EXP2 mode, as a value between 0 and 1. The default is 0.001.
  linearStart | Distance in world units at which linear fog starts to encroach. Only applicable if mode is FOG_LINEAR.
  linearEnd | Distance in world units at which linear fog becomes completely opaque. Only applicable if mode is FOG_LINEAR.

References Ogre::FOG_NONE, and Ogre::ColourValue::White.

## ◆ getFogMode()

FogMode Ogre::SceneManager::getFogMode | ( | void |  | ) | const

Returns the fog mode for the scene.

## ◆ getFogColour()

const ColourValue & Ogre::SceneManager::getFogColour | ( | void |  | ) | const

Returns the fog colour for the scene.

## ◆ getFogStart()

Real Ogre::SceneManager::getFogStart | ( | void |  | ) | const

Returns the fog start distance for the scene.

## ◆ getFogEnd()

Real Ogre::SceneManager::getFogEnd | ( | void |  | ) | const

Returns the fog end distance for the scene.

## ◆ getFogDensity()

Real Ogre::SceneManager::getFogDensity | ( | void |  | ) | const

Returns the fog density for the scene.

## ◆ createBillboardSet() [1/2]

BillboardSet * Ogre::SceneManager::createBillboardSet | ( | unsigned int | poolSize = 20 | ) |

Creates a new BillboardSet for use with this scene manager.

This method creates a new BillboardSet which is registered with the SceneManager. The SceneManager will destroy this object when it shuts down or when the SceneManager::clearScene method is called, so the caller does not have to worry about destroying this object (in fact, it definitely should not do this).

Parameters

  poolSize | The initial size of the pool of billboards (see BillboardSet for more information)

## ◆ createBillboardSet() [2/2]

BillboardSet * Ogre::SceneManager::createBillboardSet | ( | const String & | name,
|  | unsigned int | poolSize = 20 )

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

Creates a new BillboardSet for use with this scene manager.

This method creates a new BillboardSet which is registered with the SceneManager. The SceneManager will destroy this object when it shuts down or when the SceneManager::clearScene method is called, so the caller does not have to worry about destroying this object (in fact, it definitely should not do this).

Parameters

  poolSize | The initial size of the pool of billboards (see BillboardSet for more information)
  name | The name to give to this billboard set. Must be unique.

## ◆ getBillboardSet()

BillboardSet * Ogre::SceneManager::getBillboardSet | ( | const String & | name | ) | const

Retrieves a pointer to the named BillboardSet.

Note
  Throws an exception if the named instance does not exist

## ◆ hasBillboardSet()

bool Ogre::SceneManager::hasBillboardSet | ( | const String & | name | ) | const
| inline

Returns whether a billboardset with the given name exists.

References hasMovableObject(), and Ogre::MOT_BILLBOARD_SET.

## ◆ destroyBillboardSet() [1/2]

void Ogre::SceneManager::destroyBillboardSet | ( | MovableObject * | set | ) |
| inline

Removes & destroys an BillboardSet from the SceneManager.

References destroyMovableObject().

## ◆ destroyBillboardSet() [2/2]

void Ogre::SceneManager::destroyBillboardSet | ( | const String & | name | ) |
| inline

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

References destroyMovableObject(), and Ogre::MOT_BILLBOARD_SET.

## ◆ destroyAllBillboardSets()

void Ogre::SceneManager::destroyAllBillboardSets | ( | void |  | ) |
| inline

Removes & destroys all BillboardSets.

References destroyAllMovableObjectsByType(), and Ogre::MOT_BILLBOARD_SET.

## ◆ _applySceneAnimations()

void Ogre::SceneManager::_applySceneAnimations | ( | void |  | ) |

Internal method for applying animations to scene nodes.

Uses the internally stored AnimationState objects to apply animation to SceneNodes.

## ◆ createAnimation()

Animation * Ogre::SceneManager::createAnimation | ( | const String & | name,
|  | Real | length )
| overridevirtual

Creates an animation which can be used to animate scene nodes.

An animation is a collection of 'tracks' which over time change the position / orientation of Node objects. In this case, the animation will likely have tracks to modify the position / orientation of SceneNode objects, e.g. to make objects move along a path.

  You don't need to use an Animation object to move objects around - you can do it yourself using the methods of the Node in your FrameListener class. However, when you need relatively complex scripted animation, this is the class to use since it will interpolate between keyframes for you and generally make the whole process easier to manage.

  A single animation can affect multiple Node objects (each AnimationTrack affects a single Node). In addition, through animation blending a single Node can be affected by multiple animations, although this is more useful when performing skeletal animation (see Skeleton::createAnimation).

Note
  whilst it uses the same classes, the animations created here are kept separate from the skeletal animations of meshes (each Skeleton owns those animations).

Parameters

  name | The name of the animation, must be unique within this container.
  length | The length of the animation in seconds

Implements Ogre::AnimationContainer.

## ◆ getAnimation() [1/2]

Animation * Ogre::SceneManager::getAnimation | ( | const String & | name | ) | const
| overridevirtual

Looks up an Animation object previously created with createAnimation.

Note
  Throws an exception if the named instance does not exist

Parameters

  name | The name of the animation.

Implements Ogre::AnimationContainer.

## ◆ hasAnimation()

bool Ogre::SceneManager::hasAnimation | ( | const String & | name | ) | const
| overridevirtual

Returns whether this object contains the named animation.

Implements Ogre::AnimationContainer.

## ◆ getNumAnimations()

uint16 Ogre::SceneManager::getNumAnimations | ( | void |  | ) | const
| inlineoverridevirtual

Gets the number of animations in this container.

Implements Ogre::AnimationContainer.

## ◆ getAnimation() [2/2]

Animation * Ogre::SceneManager::getAnimation | ( | unsigned short | index | ) | const
| overridevirtual

Retrieve an animation by index.

Implements Ogre::AnimationContainer.

## ◆ removeAnimation()

void Ogre::SceneManager::removeAnimation | ( | const String & | name | ) |
| overridevirtual

Remove & destroy an Animation from this container.

Implements Ogre::AnimationContainer.

Referenced by destroyAnimation().

## ◆ destroyAnimation()

void Ogre::SceneManager::destroyAnimation | ( | const String & | name | ) |
| inline

References removeAnimation().

## ◆ destroyAllAnimations()

void Ogre::SceneManager::destroyAllAnimations | ( | void |  | ) |

Removes all animations created using this SceneManager.

## ◆ createAnimationState()

AnimationState * Ogre::SceneManager::createAnimationState | ( | const String & | animName | ) |

Create an AnimationState object for managing application of animations.

You can create Animation objects for animating SceneNode obejcts using the createAnimation method. However, in order to actually apply those animations you have to call methods on Node and Animation in a particular order (namely Node::resetToInitialState and Animation::apply). To make this easier and to help track the current time position of animations, the AnimationState object is provided. So if you don't want to control animation application manually, call this method, update the returned object as you like every frame and let SceneManager apply the animation state for you.

  Remember, AnimationState objects are disabled by default at creation time. Turn them on when you want them using their setEnabled method.

  Note that any SceneNode affected by this automatic animation will have it's state reset to it's initial position before application of the animation. Unless specifically modified using Node::setInitialState the Node assumes it's initial state is at the origin. If you want the base state of the SceneNode to be elsewhere, make your changes to the node using the standard transform methods, then call setInitialState to 'bake' this reference position into the node.

  If the target of your animation is to be a generic AnimableValue, you should ensure that it has a base value set (unlike nodes this has no default).

See also
  AnimableValue::setAsBaseValue.

Parameters

  animName | The name of an animation created already with createAnimation.

## ◆ getAnimationState()

AnimationState * Ogre::SceneManager::getAnimationState | ( | const String & | animName | ) | const

Retrieves animation state as previously created using createAnimationState.

Note
  Throws an exception if the named instance does not exist

## ◆ hasAnimationState()

bool Ogre::SceneManager::hasAnimationState | ( | const String & | name | ) | const

Returns whether an animation state with the given name exists.

## ◆ destroyAnimationState()

void Ogre::SceneManager::destroyAnimationState | ( | const String & | name | ) |

Destroys an AnimationState.

You should ensure that none of your code is referencing this animation state object since the memory will be freed.

## ◆ destroyAllAnimationStates()

void Ogre::SceneManager::destroyAllAnimationStates | ( | void |  | ) |

Removes all animation states created using this SceneManager.

## ◆ getAnimationIterator()

AnimationIterator Ogre::SceneManager::getAnimationIterator | ( | void |  | ) |
| inline

Returns a specialised MapIterator over all animations in the scene.

Deprecated
  use getAnimations()

## ◆ getAnimations()

const AnimationList & Ogre::SceneManager::getAnimations | ( |  | ) | const
| inline

Returns a const version of the animation list.

## ◆ getAnimationStateIterator()

AnimationStateIterator Ogre::SceneManager::getAnimationStateIterator | ( | void |  | ) |
| inline

Returns a specialised MapIterator over all animation states in the scene.

Deprecated
  use getAnimationStates()

## ◆ getAnimationStates()

const AnimationStateMap & Ogre::SceneManager::getAnimationStates | ( |  | ) |
| inline

Returns a specialised Map over all animation states in the scene.

## ◆ manualRender() [1/2]

void Ogre::SceneManager::manualRender | ( | RenderOperation * | rend,
|  | Pass * | pass,
|  | Viewport * | vp,
|  | const Affine3 & | worldMatrix,
|  | const Affine3 & | viewMatrix,
|  | const Matrix4 & | projMatrix,
|  | bool | doBeginEndFrame = false )

Manual rendering method, for advanced users only.

This method allows you to send rendering commands through the pipeline on demand, bypassing OGRE's normal world processing. You should only use this if you really know what you're doing; OGRE does lots of things for you that you really should let it do. However, there are times where it may be useful to have this manual interface, for example overlaying something on top of the scene rendered by OGRE.

  Because this is an instant rendering method, timing is important. The best time to call it is from a RenderTargetListener event handler.

  Don't call this method a lot, it's designed for rare (1 or 2 times per frame) use. Calling it regularly per frame will cause frame rate drops!

Parameters

  rend | A RenderOperation object describing the rendering op
  pass | The Pass to use for this render
  vp | Pointer to the viewport to render to, or 0 to use the current viewport
  worldMatrix | The transform to apply from object to world space
  viewMatrix | The transform to apply from world to view space
  projMatrix | The transform to apply from view to screen space
  doBeginEndFrame | If true, beginFrame() and endFrame() are called, otherwise not. You should leave this as false if you are calling this within the main render loop.

## ◆ manualRender() [2/2]

void Ogre::SceneManager::manualRender | ( | Renderable * | rend,
|  | const Pass * | pass,
|  | Viewport * | vp,
|  | const Affine3 & | viewMatrix,
|  | const Matrix4 & | projMatrix,
|  | bool | doBeginEndFrame = false,
|  | bool | lightScissoringClipping = true,
|  | bool | doLightIteration = true,
|  | const LightList * | manualLightList = 0 )

Manual rendering method for rendering a single object.

Parameters

  rend | The renderable to issue to the pipeline
  pass | The pass to use
  vp | Pointer to the viewport to render to, or 0 to use the existing viewport
  doBeginEndFrame | If true, beginFrame() and endFrame() are called, otherwise not. You should leave this as false if you are calling this within the main render loop.
  viewMatrix | The transform to apply from world to view space
  projMatrix | The transform to apply from view to screen space
  lightScissoringClipping | If true, passes that have the getLightScissorEnabled and/or getLightClipPlanesEnabled flags will cause calculation and setting of scissor rectangle and user clip planes.
  doLightIteration | If true, this method will issue the renderable to the pipeline possibly multiple times, if the pass indicates it should be done once per light
  manualLightList | Only applicable if doLightIteration is false, this method allows you to pass in a previously determined set of lights which will be used for a single render of this object.

## ◆ getRenderQueue()

RenderQueue * Ogre::SceneManager::getRenderQueue | ( | void |  | ) |

Retrieves the internal render queue, for advanced users only.

The render queue is mainly used internally to manage the scene object rendering queue, it also exports some methods to allow advanced users to configure the behavior of rendering process. Most methods provided by RenderQueue are supposed to be used internally only, you should reference to the RenderQueue API for more information. Do not access this directly unless you know what you are doing.

## ◆ addRenderQueueListener()

void Ogre::SceneManager::addRenderQueueListener | ( | RenderQueueListener * | newListener | ) |

Registers a new RenderQueueListener which will be notified when render queues are processed.

## ◆ removeRenderQueueListener()

void Ogre::SceneManager::removeRenderQueueListener | ( | RenderQueueListener * | delListener | ) |

Removes a listener previously added with addRenderQueueListener.

## ◆ addRenderObjectListener()

void Ogre::SceneManager::addRenderObjectListener | ( | RenderObjectListener * | newListener | ) |

Registers a new Render Object Listener which will be notified when rendering an object.

## ◆ removeRenderObjectListener()

void Ogre::SceneManager::removeRenderObjectListener | ( | RenderObjectListener * | delListener | ) |

Removes a listener previously added with addRenderObjectListener.

## ◆ addSpecialCaseRenderQueue()

void Ogre::SceneManager::addSpecialCaseRenderQueue | ( | uint8 | qid | ) |

Adds an item to the 'special case' render queue list.

Normally all render queues are rendered, in their usual sequence, only varying if a RenderQueueListener nominates for the queue to be repeated or skipped. This method allows you to add a render queue to a 'special case' list, which varies the behaviour. The effect of this list depends on the 'mode' in which this list is in, which might be to exclude these render queues, or to include them alone (excluding all other queues). This allows you to perform broad selective rendering without requiring a RenderQueueListener.

Parameters

  qid | The identifier of the queue which should be added to the special case list. Nothing happens if the queue is already in the list.

## ◆ removeSpecialCaseRenderQueue()

void Ogre::SceneManager::removeSpecialCaseRenderQueue | ( | uint8 | qid | ) |

Removes an item to the 'special case' render queue list.

See also
  SceneManager::addSpecialCaseRenderQueue

Parameters

  qid | The identifier of the queue which should be removed from the special case list. Nothing happens if the queue is not in the list.

## ◆ clearSpecialCaseRenderQueues()

void Ogre::SceneManager::clearSpecialCaseRenderQueues | ( | void |  | ) |

Clears the 'special case' render queue list.

See also
  SceneManager::addSpecialCaseRenderQueue

## ◆ setSpecialCaseRenderQueueMode()

void Ogre::SceneManager::setSpecialCaseRenderQueueMode | ( | SpecialCaseRenderQueueMode | mode | ) |

Sets the way the special case render queue list is processed.

See also
  SceneManager::addSpecialCaseRenderQueue

Parameters

  mode | The mode of processing

## ◆ getSpecialCaseRenderQueueMode()

SpecialCaseRenderQueueMode Ogre::SceneManager::getSpecialCaseRenderQueueMode | ( | void |  | ) |

Gets the way the special case render queue list is processed.

## ◆ isRenderQueueToBeProcessed()

bool Ogre::SceneManager::isRenderQueueToBeProcessed | ( | uint8 | qid | ) |

Returns whether or not the named queue will be rendered based on the current 'special case' render queue list and mode.

See also
  SceneManager::addSpecialCaseRenderQueue

Parameters

  qid | The identifier of the queue which should be tested

Returns
  true if the queue will be rendered, false otherwise

## ◆ setWorldGeometryRenderQueue()

void Ogre::SceneManager::setWorldGeometryRenderQueue | ( | uint8 | qid | ) |
| inline

Sets the render queue that the world geometry (if any) this SceneManager renders will be associated with.

SceneManagers which provide 'world geometry' should place it in a specialised render queue in order to make it possible to enable / disable it easily using the addSpecialCaseRenderQueue method. Even if the SceneManager does not use the render queues to render the world geometry, it should still pick a queue to represent it's manual rendering, and check isRenderQueueToBeProcessed before rendering.

Note
  Setting this may not affect the actual ordering of rendering the world geometry, if the world geometry is being rendered manually by the SceneManager. If the SceneManager feeds world geometry into the queues, however, the ordering will be affected.

## ◆ getWorldGeometryRenderQueue()

uint8 Ogre::SceneManager::getWorldGeometryRenderQueue | ( |  | ) |
| inline

Gets the render queue that the world geometry (if any) this SceneManager renders will be associated with.

SceneManagers which provide 'world geometry' should place it in a specialised render queue in order to make it possible to enable / disable it easily using the addSpecialCaseRenderQueue method. Even if the SceneManager does not use the render queues to render the world geometry, it should still pick a queue to represent it's manual rendering, and check isRenderQueueToBeProcessed before rendering.

## ◆ _notifyAutotrackingSceneNode()

void Ogre::SceneManager::_notifyAutotrackingSceneNode | ( | SceneNode * | node,
|  | bool | autoTrack )

Internal method for notifying the manager that a SceneNode is autotracking.

## ◆ createAABBQuery()

virtual AxisAlignedBoxSceneQuery * Ogre::SceneManager::createAABBQuery | ( | const AxisAlignedBox & | box,
|  | uint32 | mask = 0xFFFFFFFF )
| virtual

Creates an AxisAlignedBoxSceneQuery for this scene manager.

This method creates a new instance of a query object for this scene manager, for an axis aligned box region. See SceneQuery and AxisAlignedBoxSceneQuery for full details.

  The instance returned from this method must be destroyed by calling SceneManager::destroyQuery when it is no longer required.

Parameters

  box | Details of the box which describes the region for this query.
  mask | The query mask to apply to this query; can be used to filter out certain objects; see SceneQuery for details.

Reimplemented in Ogre::OctreeSceneManager, and Ogre::PCZSceneManager.

## ◆ createSphereQuery()

virtual SphereSceneQuery * Ogre::SceneManager::createSphereQuery | ( | const Sphere & | sphere,
|  | uint32 | mask = 0xFFFFFFFF )
| virtual

Creates a SphereSceneQuery for this scene manager.

This method creates a new instance of a query object for this scene manager, for a spherical region. See SceneQuery and SphereSceneQuery for full details.

  The instance returned from this method must be destroyed by calling SceneManager::destroyQuery when it is no longer required.

Parameters

  sphere | Details of the sphere which describes the region for this query.
  mask | The query mask to apply to this query; can be used to filter out certain objects; see SceneQuery for details.

Reimplemented in Ogre::OctreeSceneManager, and Ogre::PCZSceneManager.

## ◆ createPlaneBoundedVolumeQuery()

virtual PlaneBoundedVolumeListSceneQuery * Ogre::SceneManager::createPlaneBoundedVolumeQuery | ( | const PlaneBoundedVolumeList & | volumes,
|  | uint32 | mask = 0xFFFFFFFF )
| virtual

Creates a PlaneBoundedVolumeListSceneQuery for this scene manager.

This method creates a new instance of a query object for this scene manager, for a region enclosed by a set of planes (normals pointing inwards). See SceneQuery and PlaneBoundedVolumeListSceneQuery for full details.

  The instance returned from this method must be destroyed by calling SceneManager::destroyQuery when it is no longer required.

Parameters

  volumes | Details of the volumes which describe the region for this query.
  mask | The query mask to apply to this query; can be used to filter out certain objects; see SceneQuery for details.

Reimplemented in Ogre::OctreeSceneManager, and Ogre::PCZSceneManager.

## ◆ createRayQuery()

virtual RaySceneQuery * Ogre::SceneManager::createRayQuery | ( | const Ray & | ray,
|  | uint32 | mask = 0xFFFFFFFF )
| virtual

Creates a RaySceneQuery for this scene manager.

This method creates a new instance of a query object for this scene manager, looking for objects which fall along a ray. See SceneQuery and RaySceneQuery for full details.

  The instance returned from this method must be destroyed by calling SceneManager::destroyQuery when it is no longer required.

Parameters

  ray | Details of the ray which describes the region for this query.
  mask | The query mask to apply to this query; can be used to filter out certain objects; see SceneQuery for details.

Reimplemented in Ogre::BspSceneManager, Ogre::OctreeSceneManager, and Ogre::PCZSceneManager.

## ◆ createIntersectionQuery()

virtual IntersectionSceneQuery * Ogre::SceneManager::createIntersectionQuery | ( | uint32 | mask = 0xFFFFFFFF | ) |
| virtual

Creates an IntersectionSceneQuery for this scene manager.

This method creates a new instance of a query object for locating intersecting objects. See SceneQuery and IntersectionSceneQuery for full details.

  The instance returned from this method must be destroyed by calling SceneManager::destroyQuery when it is no longer required.

Parameters

  mask | The query mask to apply to this query; can be used to filter out certain objects; see SceneQuery for details.

Reimplemented in Ogre::BspSceneManager, Ogre::OctreeSceneManager, and Ogre::PCZSceneManager.

## ◆ destroyQuery()

void Ogre::SceneManager::destroyQuery | ( | SceneQuery * | query | ) |

Destroys a scene query of any type.

## ◆ setShadowTechnique()

void Ogre::SceneManager::setShadowTechnique | ( | ShadowTechnique | technique | ) |

Sets the general shadow technique to be used in this scene.

There are multiple ways to generate shadows in a scene, and each has strengths and weaknesses.

- Stencil-based approaches can be used to draw very long, extreme shadows without loss of precision and the 'additive' version can correctly show the shadowing of complex effects like bump mapping because they physically exclude the light from those areas. However, the edges are very sharp and stencils cannot handle transparency, and they involve a fair amount of CPU work in order to calculate the shadow volumes, especially when animated objects are involved.
- Texture-based approaches are good for handling transparency (they can, for example, correctly shadow a mesh which uses alpha to represent holes), and they require little CPU overhead, and can happily shadow geometry which is deformed by a vertex program, unlike stencil shadows. However, they have a fixed precision which can introduce 'jaggies' at long range and have fillrate issues of their own.

  We support 2 kinds of stencil shadows, and 2 kinds of texture-based shadows, and one simple decal approach. The 2 stencil approaches differ in the amount of multipass work that is required - the modulative approach simply 'darkens' areas in shadow after the main render, which is the least expensive, whilst the additive approach has to perform a render per light and adds the cumulative effect, which is more expensive but more accurate. The texture based shadows both work in roughly the same way, the only difference is that the shadowmap approach is slightly more accurate, but requires a more recent graphics card.

  Note that because mixing many shadow techniques can cause problems, only one technique is supported at once. Also, you should call this method at the start of the scene setup.

Parameters

  technique | The shadowing technique to use for the scene.

## ◆ getShadowTechnique()

ShadowTechnique Ogre::SceneManager::getShadowTechnique | ( | void |  | ) | const
| inline

Gets the current shadow technique.

## ◆ setShadowColour()

void Ogre::SceneManager::setShadowColour | ( | const ColourValue & | colour | ) |

Set the colour used to modulate areas in shadow.

This is only applicable for shadow techniques which involve darkening the area in shadow, as opposed to masking out the light. This colour provided is used as a modulative value to darken the areas.

## ◆ getShadowColour()

const ColourValue & Ogre::SceneManager::getShadowColour | ( | void |  | ) | const

Get the colour used to modulate areas in shadow.

This is only applicable for shadow techniques which involve darkening the area in shadow, as opposed to masking out the light. This colour provided is used as a modulative value to darken the areas.

## ◆ setShadowDirectionalLightExtrusionDistance()

void Ogre::SceneManager::setShadowDirectionalLightExtrusionDistance | ( | Real | dist | ) |

Sets the distance a shadow volume is extruded for a directional light.

Although directional lights are essentially infinite, there are many reasons to limit the shadow extrusion distance to a finite number, not least of which is compatibility with older cards (which do not support infinite positions), and shadow caster elimination.

  The default value is 10,000 world units. This does not apply to point lights or spotlights, since they extrude up to their attenuation range.

## ◆ getShadowDirectionalLightExtrusionDistance()

Real Ogre::SceneManager::getShadowDirectionalLightExtrusionDistance | ( | void |  | ) | const

Gets the distance a shadow volume is extruded for a directional light.

## ◆ isShadowTechniqueStencilBased()

bool Ogre::SceneManager::isShadowTechniqueStencilBased | ( | void |  | ) | const
| inline

Is there a stencil shadow based shadowing technique in use?

References Ogre::SHADOWDETAILTYPE_STENCIL.

## ◆ isShadowTechniqueTextureBased()

bool Ogre::SceneManager::isShadowTechniqueTextureBased | ( | void |  | ) | const
| inline

Is there a texture shadow based shadowing technique in use?

References Ogre::SHADOWDETAILTYPE_TEXTURE.

## ◆ isShadowTechniqueModulative()

bool Ogre::SceneManager::isShadowTechniqueModulative | ( | void |  | ) | const
| inline

Is there a modulative shadowing technique in use?

References Ogre::SHADOWDETAILTYPE_MODULATIVE.

## ◆ isShadowTechniqueAdditive()

bool Ogre::SceneManager::isShadowTechniqueAdditive | ( | void |  | ) | const
| inline

Is there an additive shadowing technique in use?

References Ogre::SHADOWDETAILTYPE_ADDITIVE.

## ◆ isShadowTechniqueIntegrated()

bool Ogre::SceneManager::isShadowTechniqueIntegrated | ( | void |  | ) | const
| inline

Is the shadow technique integrated into primary materials?

References Ogre::SHADOWDETAILTYPE_INTEGRATED.

## ◆ isShadowTechniqueInUse()

bool Ogre::SceneManager::isShadowTechniqueInUse | ( | void |  | ) | const
| inline

Is there any shadowing technique in use?

References Ogre::SHADOWTYPE_NONE.

## ◆ setShowDebugShadows()

void Ogre::SceneManager::setShowDebugShadows | ( | bool | debug | ) |
| inline

Enables / disables the rendering of debug information for shadows.

## ◆ getShowDebugShadows()

bool Ogre::SceneManager::getShowDebugShadows | ( | void |  | ) | const
| inline

Are debug shadows shown?

## ◆ setShadowIndexBufferSize()

void Ogre::SceneManager::setShadowIndexBufferSize | ( | size_t | size | ) |

Sets the maximum size of the index buffer used to render shadow primitives.

This method allows you to tweak the size of the index buffer used to render shadow primitives (including stencil shadow volumes). The default size is 51,200 entries, which is 100k of GPU memory, or enough to render approximately 17,000 triangles. You can reduce this as long as you do not have any models / world geometry chunks which could require more than the amount you set.

  The maximum number of triangles required to render a single shadow volume (including light and dark caps when needed) will be 3x the number of edges on the light silhouette, plus the number of light-facing triangles. On average, half the triangles will be facing toward the light, but the number of triangles in the silhouette entirely depends on the mesh - angular meshes will have a higher silhouette tris/mesh tris ratio than a smooth mesh. You can estimate the requirements for your particular mesh by rendering it alone in a scene with shadows enabled and a single light - rotate it or the light and make a note of how high the triangle count goes (remembering to subtract the mesh triangle count)

Parameters

  size | The number of indexes; divide this by 3 to determine the number of triangles.

## ◆ getShadowIndexBufferSize()

size_t Ogre::SceneManager::getShadowIndexBufferSize | ( | void |  | ) | const
| inline

Get the size of the shadow index buffer.

## ◆ setShadowUseInfiniteFarPlane()

void Ogre::SceneManager::setShadowUseInfiniteFarPlane | ( | bool | enable | ) |
| inline

Sets whether we should use an infinite camera far plane when rendering stencil shadows.

Stencil shadow coherency is very reliant on the shadow volume not being clipped by the far plane. If this clipping happens, you get a kind of 'negative' shadow effect. The best way to achieve coherency is to move the far plane of the camera out to infinity, thus preventing the far plane from clipping the shadow volumes. When combined with vertex program extrusion of the volume to infinity, which Ogre does when available, this results in very robust shadow volumes. For this reason, when you enable stencil shadows, Ogre automatically changes your camera settings to project to infinity if the card supports it. You can disable this behaviour if you like by calling this method; although you can never enable infinite projection if the card does not support it.

  If you disable infinite projection, or it is not available, you need to be far more careful with your light attenuation / directional light extrusion distances to avoid clipping artefacts at the far plane.

Note
  Recent cards will generally support infinite far plane projection. However, we have found some cases where they do not, especially on Direct3D. There is no standard capability we can check to validate this, so we use some heuristics based on experience:
  - OpenGL always seems to support it no matter what the card
  - Direct3D on non-vertex program capable systems (including vertex program capable cards on Direct3D7) does not support it
  - Direct3D on GeForce3 and GeForce4 Ti does not seem to support infinite projection
  Therefore in the RenderSystem implementation, we may veto the use of an infinite far plane based on these heuristics.

## ◆ setShadowUseLightClipPlanes()

void Ogre::SceneManager::setShadowUseLightClipPlanes | ( | bool | enabled | ) |
| inline

Sets whether when using a built-in additive shadow mode, user clip planes should be used to restrict light rendering.

## ◆ getShadowUseLightClipPlanes()

bool Ogre::SceneManager::getShadowUseLightClipPlanes | ( |  | ) | const
| inline

Gets whether when using a built-in additive shadow mode, user clip planes should be used to restrict light rendering.

## ◆ setShadowFarDistance()

void Ogre::SceneManager::setShadowFarDistance | ( | Real | distance | ) |

Sets the default maximum distance away from the camera that shadows will be visible.

You have to call this function before you create lights or the default distance of zero will be used.

Shadow techniques can be expensive, therefore it is a good idea to limit them to being rendered close to the camera if possible, and to skip the expense of rendering shadows for distance objects. This method allows you to set the distance at which shadows will no longer be rendered.

Note
  Each shadow technique can interpret this subtely differently. For example, one technique may use this to eliminate casters, another might use it to attenuate the shadows themselves. You should tweak this value to suit your chosen shadow technique and scene setup.

## ◆ getShadowFarDistance()

Real Ogre::SceneManager::getShadowFarDistance | ( | void |  | ) | const
| inline

Gets the default maximum distance away from the camera that shadows will be visible.

## ◆ getShadowFarDistanceSquared()

Real Ogre::SceneManager::getShadowFarDistanceSquared | ( | void |  | ) | const
| inline

## ◆ updateShadowTextures()

virtual void Ogre::SceneManager::updateShadowTextures | ( | Camera * | cam,
|  | Viewport * | vp,
|  | const LightList * | lightList = 0 )
| virtual

Method for update shadow textures ready for use in a regular render Do not call manually unless before frame start or rendering is paused If lightList is not supplied, will render all lights in frustum.

Reimplemented in Ogre::PCZSceneManager.

Referenced by prepareShadowTextures().

## ◆ prepareShadowTextures()

void Ogre::SceneManager::prepareShadowTextures | ( | Camera * | cam,
|  | Viewport * | vp,
|  | const LightList * | lightList = 0 )
| inline

Deprecated
  use updateShadowTextures

References updateShadowTextures().

## ◆ setShadowTextureSize()

void Ogre::SceneManager::setShadowTextureSize | ( | unsigned short | size | ) |
| inline

Set the size of the texture used for all texture-based shadows.

The larger the shadow texture, the better the detail on texture based shadows, but obviously this takes more memory. The default size is 512. Sizes must be a power of 2.

Note
  This is the simple form, see setShadowTextureConfig for the more complex form.

## ◆ setShadowTextureConfig() [1/2]

void Ogre::SceneManager::setShadowTextureConfig | ( | size_t | shadowIndex,
|  | uint16 | width,
|  | uint16 | height,
|  | PixelFormat | format,
|  | uint16 | fsaa = 0,
|  | uint16 | depthBufferPoolId = 1 )
| inline

Set the detailed configuration for a shadow texture.

Parameters

  shadowIndex | The index of the texture to configure, must be < the number of shadow textures setting
  width | The width of the texture
  height | The height of the texture
  format | The pixel format of the texture
  fsaa | The level of multisampling to use. Ignored if the device does not support it.
  depthBufferPoolId | The pool # it should query the depth buffers from

## ◆ setShadowTextureConfig() [2/2]

void Ogre::SceneManager::setShadowTextureConfig | ( | size_t | shadowIndex,
|  | const ShadowTextureConfig & | config )
| inline

Set the detailed configuration for a shadow texture.

Parameters

  shadowIndex | The index of the texture to configure, must be < the number of shadow textures setting
  config | Configuration structure

## ◆ getShadowTextureConfigList()

const ShadowTextureConfigList & Ogre::SceneManager::getShadowTextureConfigList | ( |  | ) | const
| inline

Get the current shadow texture settings.

## ◆ getShadowTextureConfigIterator()

ConstShadowTextureConfigIterator Ogre::SceneManager::getShadowTextureConfigIterator | ( |  | ) | const

Deprecated
  use getShadowTextureConfigList

## ◆ setShadowTexturePixelFormat()

void Ogre::SceneManager::setShadowTexturePixelFormat | ( | PixelFormat | fmt | ) |
| inline

Set the pixel format of the textures used for texture-based shadows.

By default, a colour texture is used (PF_BYTE_RGBA) for texture shadows, but if you want to use more advanced texture shadow types you can alter this. If you do, you will have to also call setShadowTextureCasterMaterial and setShadowTextureReceiverMaterial to provide shader-based materials to use these customised shadow texture formats.

Note
  This is the simple form, see setShadowTextureConfig for the more complex form.

## ◆ setShadowTextureFSAA()

void Ogre::SceneManager::setShadowTextureFSAA | ( | unsigned short | fsaa | ) |
| inline

Set the level of multisample AA of the textures used for texture-based shadows.

By default, the level of multisample AA is zero.

Note
  This is the simple form, see setShadowTextureConfig for the more complex form.

## ◆ setShadowTextureCount()

void Ogre::SceneManager::setShadowTextureCount | ( | size_t | count | ) |
| inline

Set the number of textures allocated for texture-based shadows.

The default number of textures assigned to deal with texture based shadows is 1; however this means you can only have one light casting shadows at the same time. You can increase this number in order to make this more flexible, but be aware of the texture memory it will use.

## ◆ getShadowTextureCount()

size_t Ogre::SceneManager::getShadowTextureCount | ( | void |  | ) | const
| inline

Deprecated
  use getShadowTextureConfigList

## ◆ setShadowTextureCountPerLightType()

void Ogre::SceneManager::setShadowTextureCountPerLightType | ( | Light::LightTypes | type,
|  | size_t | count )
| inline

Set the number of shadow textures a light type uses.

The default for all light types is 1. This means that each light uses only 1 shadow texture. Call this if you need more than 1 shadow texture per light, E.G. PSSM.

Note
  This feature only works with the Integrated shadow technique. Also remember to increase the total number of shadow textures you request appropriately (e.g. via setShadowTextureCount)!!

## ◆ getShadowTextureCountPerLightType()

size_t Ogre::SceneManager::getShadowTextureCountPerLightType | ( | Light::LightTypes | type | ) | const
| inline

Get the number of shadow textures is assigned for the given light type.

## ◆ setShadowTextureSettings()

void Ogre::SceneManager::setShadowTextureSettings | ( | uint16 | size,
|  | uint16 | count,
|  | PixelFormat | fmt = PF_BYTE_RGBA,
|  | uint16 | fsaa = 0,
|  | uint16 | depthBufferPoolId = 1 )
| inline

Sets the size and count of textures used in texture-based shadows.

See also
  setShadowTextureSize and setShadowTextureCount for details, this method just allows you to change both at once, which can save on reallocation if the textures have already been created.

Note
  This is the simple form, see setShadowTextureConfig for the more complex form.

References Ogre::PF_BYTE_RGBA.

## ◆ setShadowTextureCompositor()

void Ogre::SceneManager::setShadowTextureCompositor | ( | const String & | compositorName,
|  | const String & | resourceGroup = RGN_DEFAULT )
| inline

Sets the configuration of textures used for texture-based shadows.

use a .compositor script definition to set up the shadow textures instead of configuring them by code. This is both easier and more flexible then the above methods.

References OGRE_RESOURCE_GROUP_INIT.

## ◆ getShadowTexture()

const TexturePtr & Ogre::SceneManager::getShadowTexture | ( | size_t | shadowIndex | ) |
| inline

Get a reference to the shadow texture currently in use at the given index.

Note
  If you change shadow settings, this reference may no longer be correct, so be sure not to hold the returned reference over texture shadow configuration changes.

## ◆ setShadowDirLightTextureOffset()

void Ogre::SceneManager::setShadowDirLightTextureOffset | ( | Real | offset | ) |
| inline

Sets the proportional distance which a texture shadow which is generated from a directional light will be offset into the camera view to make best use of texture space.

When generating a shadow texture from a directional light, an approximation is used since it is not possible to render the entire scene to one texture. The texture is projected onto an area centred on the camera, and is the shadow far distance * 2 in length (it is square). This wastes a lot of texture space outside the frustum though, so this offset allows you to move the texture in front of the camera more. However, be aware that this can cause a little shadow 'jittering' during rotation, and that if you move it too far then you'll start to get artefacts close to the camera. The value is represented as a proportion of the shadow far distance, and the default is 0.6.

## ◆ getShadowDirLightTextureOffset()

Real Ogre::SceneManager::getShadowDirLightTextureOffset | ( | void |  | ) | const
| inline

Gets the proportional distance which a texture shadow which is generated from a directional light will be offset into the camera view to make best use of texture space.

## ◆ setShadowTextureFadeStart()

void Ogre::SceneManager::setShadowTextureFadeStart | ( | Real | fadeStart | ) |
| inline

Sets the proportional distance at which texture shadows begin to fade out.

To hide the edges where texture shadows end (in directional lights) Ogre will fade out the shadow in the distance. This value is a proportional distance of the entire shadow visibility distance at which the shadow begins to fade out. The default is 0.7

## ◆ setShadowTextureFadeEnd()

void Ogre::SceneManager::setShadowTextureFadeEnd | ( | Real | fadeEnd | ) |
| inline

Sets the proportional distance at which texture shadows finish to fading out.

To hide the edges where texture shadows end (in directional lights) Ogre will fade out the shadow in the distance. This value is a proportional distance of the entire shadow visibility distance at which the shadow is completely invisible. The default is 0.9.

## ◆ setShadowTextureSelfShadow()

void Ogre::SceneManager::setShadowTextureSelfShadow | ( | bool | selfShadow | ) |

Sets whether or not texture shadows should attempt to self-shadow.

The default implementation of texture shadows uses a fixed-function colour texture projection approach for maximum compatibility, and as such cannot support self-shadowing. However, if you decide to implement a more complex shadowing technique using the setShadowTextureCasterMaterial and setShadowTextureReceiverMaterial there is a possibility you may be able to support self-shadowing (e.g by implementing a shader-based shadow map). In this case you might want to enable this option.

Parameters

  selfShadow | Whether to attempt self-shadowing with texture shadows

## ◆ getShadowTextureSelfShadow()

bool Ogre::SceneManager::getShadowTextureSelfShadow | ( | void |  | ) | const
| inline

Gets whether or not texture shadows attempt to self-shadow.

## ◆ setShadowTextureCasterMaterial()

void Ogre::SceneManager::setShadowTextureCasterMaterial | ( | const MaterialPtr & | mat | ) |
| inline

Sets the default material to use for rendering shadow casters.

By default shadow casters are rendered into the shadow texture using an automatically generated fixed-function pass. This allows basic projective texture shadows, but it's possible to use more advanced shadow techniques by overriding the caster and receiver materials, for example providing vertex and fragment programs to implement shadow maps.

  You can rely on the ambient light in the scene being set to the requested texture shadow colour, if that's useful.

Note
  Individual objects may also override the vertex program in your default material if their materials include shadow_caster_material entries, so if you use both make sure they are compatible.
  Only a single pass is allowed in your material, although multiple techniques may be used for hardware fallback.

## ◆ setShadowTextureReceiverMaterial()

void Ogre::SceneManager::setShadowTextureReceiverMaterial | ( | const MaterialPtr & | mat | ) |
| inline

Sets the default material to use for rendering shadow receivers.

By default shadow receivers are rendered as a post-pass using basic modulation. This allows basic projective texture shadows, but it's possible to use more advanced shadow techniques by overriding the caster and receiver materials, for example providing vertex and fragment programs to implement shadow maps.

  You can rely on texture unit 0 containing the shadow texture, and for the unit to be set to use projective texturing from the light (only useful if you're using fixed-function, which is unlikely; otherwise you should rely on the texture_viewproj_matrix auto binding)

Note
  Individual objects may also override the vertex program in your default material if their materials include shadow_receiver_material entries, so if you use both make sure they are compatible.
  Only a single pass is allowed in your material, although multiple techniques may be used for hardware fallback.

## ◆ setShadowCasterRenderBackFaces()

void Ogre::SceneManager::setShadowCasterRenderBackFaces | ( | bool | bf | ) |
| inline

Sets whether or not shadow casters should be rendered into shadow textures using their back faces rather than their front faces.

Rendering back faces rather than front faces into a shadow texture can help minimise depth comparison issues, if you're using depth shadowmapping. You will probably still need some biasing but you won't need as much. For solid objects the result is the same anyway, if you have objects with holes you may want to turn this option off. The default is to enable this option.

## ◆ getShadowCasterRenderBackFaces()

bool Ogre::SceneManager::getShadowCasterRenderBackFaces | ( |  | ) | const
| inline

Gets whether or not shadow casters should be rendered into shadow textures using their back faces rather than their front faces.

## ◆ setShadowCameraSetup()

void Ogre::SceneManager::setShadowCameraSetup | ( | const ShadowCameraSetupPtr & | shadowSetup | ) |

Set the shadow camera setup to use for all lights which don't have their own shadow camera setup.

See also
  ShadowCameraSetup

## ◆ getShadowCameraSetup()

const ShadowCameraSetupPtr & Ogre::SceneManager::getShadowCameraSetup | ( |  | ) | const

Get the shadow camera setup in use for all lights which don't have their own shadow camera setup.

See also
  ShadowCameraSetup

## ◆ _setActiveCompositorChain()

void Ogre::SceneManager::_setActiveCompositorChain | ( | CompositorChain * | chain | ) |
| inline

Sets the active compositor chain of the current scene being rendered.

Note
  CompositorChain does this automatically, no need to call manually.

## ◆ setLateMaterialResolving()

void Ogre::SceneManager::setLateMaterialResolving | ( | bool | isLate | ) |
| inline

Sets whether to use late material resolving or not.

If set, materials will be resolved from the materials at the pass-setting stage and not at the render queue building stage. This is useful when the active material scheme during the render queue building stage is different from the one during the rendering stage.

## ◆ isLateMaterialResolving()

bool Ogre::SceneManager::isLateMaterialResolving | ( |  | ) | const
| inline

Gets whether using late material resolving or not.

See also
  setLateMaterialResolving

## ◆ _getActiveCompositorChain()

CompositorChain * Ogre::SceneManager::_getActiveCompositorChain | ( |  | ) | const
| inline

Gets the active compositor chain of the current scene being rendered.

## ◆ addListener()

void Ogre::SceneManager::addListener | ( | Listener * | s | ) |

Add a listener which will get called back on scene manager events.

## ◆ removeListener()

void Ogre::SceneManager::removeListener | ( | Listener * | s | ) |

Remove a listener.

## ◆ addShadowTextureListener()

void Ogre::SceneManager::addShadowTextureListener | ( | ShadowTextureListener * | s | ) |

Add a listener which will get called back on shadow texture events.

## ◆ removeShadowTextureListener()

void Ogre::SceneManager::removeShadowTextureListener | ( | ShadowTextureListener * | s | ) |

Remove a listener.

## ◆ createStaticGeometry()

StaticGeometry * Ogre::SceneManager::createStaticGeometry | ( | const String & | name | ) |

Creates a StaticGeometry instance suitable for use with this SceneManager.

StaticGeometry is a way of batching up geometry into a more efficient form at the expense of being able to move it. Please read the StaticGeometry class documentation for full information.

Parameters

  name | The name to give the new object

Returns
  The new StaticGeometry instance

## ◆ getStaticGeometry()

StaticGeometry * Ogre::SceneManager::getStaticGeometry | ( | const String & | name | ) | const

Retrieve a previously created StaticGeometry instance.

Note
  Throws an exception if the named instance does not exist

## ◆ hasStaticGeometry()

bool Ogre::SceneManager::hasStaticGeometry | ( | const String & | name | ) | const

Returns whether a static geometry instance with the given name exists.

## ◆ getStaticGeometryCollection()

const StaticGeometryMap * Ogre::SceneManager::getStaticGeometryCollection | ( |  | ) | const

Returns all static geometry instances with names.

## ◆ destroyStaticGeometry() [1/2]

void Ogre::SceneManager::destroyStaticGeometry | ( | StaticGeometry * | geom | ) |

Remove & destroy a StaticGeometry instance.

## ◆ destroyStaticGeometry() [2/2]

void Ogre::SceneManager::destroyStaticGeometry | ( | const String & | name | ) |

Remove & destroy a StaticGeometry instance.

## ◆ destroyAllStaticGeometry()

void Ogre::SceneManager::destroyAllStaticGeometry | ( | void |  | ) |

Remove & destroy all StaticGeometry instances.

## ◆ createInstanceManager()

InstanceManager * Ogre::SceneManager::createInstanceManager | ( | const String & | customName,
|  | const String & | meshName,
|  | const String & | groupName,
|  | InstanceManager::InstancingTechnique | technique,
|  | size_t | numInstancesPerBatch,
|  | uint16 | flags = 0,
|  | unsigned short | subMeshIdx = 0 )

Creates an InstanceManager interface to create & manipulate instanced entities You need to call this function at least once before start calling createInstancedEntity to build up an instance based on the given mesh.

Instancing is a way of batching up geometry into a much more efficient form, but with some limitations, and still be able to move & animate it. Please see InstanceManager class documentation for full information.

Parameters

  customName | Custom name for referencing. Must be unique
  meshName | The mesh name the instances will be based upon
  groupName | The resource name where the mesh lives
  technique | Technique to use, which may be shader based, or hardware based.
  numInstancesPerBatch | Suggested number of instances per batch. The actual number may end up being lower if the technique doesn't support having so many. It can't be zero
  flags | Flags to pass to the InstanceManager see InstanceManagerFlags
  subMeshIdx | InstanceManager only supports using one submesh from the base mesh. This parameter says which submesh to pick (must be <= Mesh::getNumSubMeshes())

Returns
  The new InstanceManager instance

## ◆ getInstanceManager()

InstanceManager * Ogre::SceneManager::getInstanceManager | ( | const String & | managerName | ) | const

Retrieves an existing InstanceManager by it's name.

Note
  Throws an exception if the named InstanceManager does not exist

## ◆ hasInstanceManager()

bool Ogre::SceneManager::hasInstanceManager | ( | const String & | managerName | ) | const

Returns whether an InstanceManager with the given name exists.

## ◆ destroyInstanceManager() [1/2]

void Ogre::SceneManager::destroyInstanceManager | ( | const String & | name | ) |

Destroys an InstanceManager if it was created with createInstanceManager().

Be sure you don't have any InstancedEntity referenced somewhere which was created with this manager, since it will become a dangling pointer.

Parameters

  name | Name of the manager to remove

## ◆ destroyInstanceManager() [2/2]

void Ogre::SceneManager::destroyInstanceManager | ( | InstanceManager * | instanceManager | ) |

## ◆ destroyAllInstanceManagers()

void Ogre::SceneManager::destroyAllInstanceManagers | ( | void |  | ) |

## ◆ getNumInstancesPerBatch()

size_t Ogre::SceneManager::getNumInstancesPerBatch | ( | const String & | meshName,
|  | const String & | groupName,
|  | const String & | materialName,
|  | InstanceManager::InstancingTechnique | technique,
|  | size_t | numInstancesPerBatch,
|  | uint16 | flags = 0,
|  | unsigned short | subMeshIdx = 0 )

See also
  InstanceManager::getMaxOrBestNumInstancesPerBatch

If you've already created an InstanceManager, you can call it's getMaxOrBestNumInstancesPerBatch() function directly. Another (not recommended) way to know if the technique is unsupported is by creating an InstanceManager and use createInstancedEntity, which will return null pointer. The input parameter "numInstancesPerBatch" is a suggested value when using IM_VTFBESTFIT flag (in that case it should be non-zero)

Returns
  The ideal (or maximum, depending on flags) number of instances per batch for the given technique. Zero if technique is unsupported or errors were spotted

## ◆ createInstancedEntity()

InstancedEntity * Ogre::SceneManager::createInstancedEntity | ( | const String & | materialName,
|  | const String & | managerName )

Creates an InstancedEntity based on an existing InstanceManager.

- Return value may be null if the InstanceManger technique isn't supported
- Try to keep the number of entities with different materials to a minimum

Alternatively you can call InstanceManager::createInstancedEntity using the returned pointer from createInstanceManager()

See also
  InstanceBatch

Parameters

  materialName | Material name
  managerName | Name of the instance manager

Returns
  An InstancedEntity ready to be attached to a SceneNode

## ◆ destroyInstancedEntity()

void Ogre::SceneManager::destroyInstancedEntity | ( | InstancedEntity * | instancedEntity | ) |

Removes an InstancedEntity,.

See also
  SceneManager::createInstancedEntity &
  InstanceBatch::removeInstancedEntity

Parameters

  instancedEntity | Instance to remove

## ◆ _addDirtyInstanceManager()

void Ogre::SceneManager::_addDirtyInstanceManager | ( | InstanceManager * | dirtyManager | ) |

Called by an InstanceManager when it has at least one InstanceBatch that needs their bounds to be updated for proper culling.

Parameters

  dirtyManager | The manager with dirty batches to update

## ◆ createMovableObject() [1/2]

MovableObject * Ogre::SceneManager::createMovableObject | ( | const String & | name,
|  | const String & | typeName,
|  | const NameValuePairList * | params = 0 )

Create a movable object of the type specified.

This is the generalised form of MovableObject creation where you can create a MovableObject of any specialised type generically, including any new types registered using plugins.

Parameters

  name | The name to give the object. Must be unique within type.
  typeName | The type of object to create
  params | Optional name/value pair list to give extra parameters to the created object.

## ◆ createMovableObject() [2/2]

MovableObject * Ogre::SceneManager::createMovableObject | ( | const String & | typeName,
|  | const NameValuePairList * | params = 0 )

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

## ◆ destroyMovableObject() [1/2]

void Ogre::SceneManager::destroyMovableObject | ( | const String & | name,
|  | const String & | typeName )

Destroys a MovableObject with the name specified, of the type specified.

The MovableObject will automatically detach itself from any nodes on destruction.

Referenced by destroyBillboardChain(), destroyBillboardChain(), destroyBillboardSet(), destroyBillboardSet(), destroyEntity(), destroyEntity(), destroyLight(), destroyLight(), destroyManualObject(), destroyManualObject(), destroyParticleSystem(), destroyParticleSystem(), destroyRibbonTrail(), and destroyRibbonTrail().

## ◆ destroyMovableObject() [2/2]

void Ogre::SceneManager::destroyMovableObject | ( | MovableObject * | m | ) |

Destroys a MovableObject.

The MovableObject will automatically detach itself from any nodes on destruction.

## ◆ destroyAllMovableObjectsByType()

void Ogre::SceneManager::destroyAllMovableObjectsByType | ( | const String & | typeName | ) |

Destroy all MovableObjects of a given type.

Referenced by destroyAllBillboardChains(), destroyAllBillboardSets(), destroyAllEntities(), destroyAllLights(), destroyAllManualObjects(), destroyAllParticleSystems(), and destroyAllRibbonTrails().

## ◆ destroyAllMovableObjects()

void Ogre::SceneManager::destroyAllMovableObjects | ( | void |  | ) |

Destroy all MovableObjects.

## ◆ getMovableObject()

MovableObject * Ogre::SceneManager::getMovableObject | ( | const String & | name,
|  | const String & | typeName ) const

Get a reference to a previously created object instance.

Note
  Throws an exception if the named instance does not exist

## ◆ hasMovableObject()

bool Ogre::SceneManager::hasMovableObject | ( | const String & | name,
|  | const String & | typeName ) const

Returns whether a object instance with the given name exists.

Referenced by hasBillboardChain(), hasBillboardSet(), hasEntity(), hasLight(), hasManualObject(), hasParticleSystem(), hasRibbonTrail(), and hasScreenSpaceRect().

## ◆ getMovableObjects()

const MovableObjectMap & Ogre::SceneManager::getMovableObjects | ( | const String & | typeName | ) |

Get all MovableObect instances of a given type.

Note
  The iterator returned from this method is not thread safe, do not use this if you are creating or deleting objects of this type in another thread.

## ◆ getMovableObjectIterator()

MovableObjectIterator Ogre::SceneManager::getMovableObjectIterator | ( | const String & | typeName | ) |

Deprecated
  use getMovableObjects

## ◆ injectMovableObject()

void Ogre::SceneManager::injectMovableObject | ( | MovableObject * | m | ) |

Inject a MovableObject instance created externally.

This method 'injects' a MovableObject instance created externally into the MovableObject instance registry held in the SceneManager. You might want to use this if you have a MovableObject which you don't want to register a factory for; for example a MovableObject which cannot be generally constructed by clients.

Note
  It is important that the MovableObject has a unique name for the type, and that its getMovableType() method returns a proper type name.

## ◆ extractMovableObject() [1/2]

void Ogre::SceneManager::extractMovableObject | ( | const String & | name,
|  | const String & | typeName )

Extract a previously injected MovableObject.

Essentially this does the same as destroyMovableObject, but only removes the instance from the internal lists, it does not attempt to destroy it.

## ◆ extractMovableObject() [2/2]

void Ogre::SceneManager::extractMovableObject | ( | MovableObject * | m | ) |

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

## ◆ extractAllMovableObjectsByType()

void Ogre::SceneManager::extractAllMovableObjectsByType | ( | const String & | typeName | ) |

Extract all injected MovableObjects of a given type.

Essentially this does the same as destroyAllMovableObjectsByType, but only removes the instances from the internal lists, it does not attempt to destroy them.

## ◆ setVisibilityMask()

void Ogre::SceneManager::setVisibilityMask | ( | uint32 | vmask | ) |
| inline

Sets a mask which is bitwise 'and'ed with objects own visibility masks to determine if the object is visible.

Note that this is combined with any per-viewport visibility mask through an 'and' operation.

See also
  Viewport::setVisibilityMask

## ◆ getVisibilityMask()

uint32 Ogre::SceneManager::getVisibilityMask | ( | void |  | ) |
| inline

Gets a mask which is bitwise 'and'ed with objects own visibility masks to determine if the object is visible.

## ◆ _getCombinedVisibilityMask()

uint32 Ogre::SceneManager::_getCombinedVisibilityMask | ( | void |  | ) | const

Internal method for getting the combination between the global visibility mask and the per-viewport visibility mask.

## ◆ setFindVisibleObjects()

void Ogre::SceneManager::setFindVisibleObjects | ( | bool | find | ) |
| inline

Sets whether the SceneManager should search for visible objects, or whether they are being manually handled.

This is an advanced function, you should not use this unless you know what you are doing.

## ◆ getFindVisibleObjects()

bool Ogre::SceneManager::getFindVisibleObjects | ( | void |  | ) |
| inline

Gets whether the SceneManager should search for visible objects, or whether they are being manually handled.

## ◆ setFlipCullingOnNegativeScale()

void Ogre::SceneManager::setFlipCullingOnNegativeScale | ( | bool | n | ) |
| inline

Set whether to automatically flip the culling mode on objects whenever they are negatively scaled.

Negativelyl scaling an object has the effect of flipping the triangles, so the culling mode should probably be inverted to deal with this. If you would prefer to manually manage this, set this option to 'false' and use different materials with Pass::setCullingMode set manually as needed.

## ◆ getFlipCullingOnNegativeScale()

bool Ogre::SceneManager::getFlipCullingOnNegativeScale | ( |  | ) | const
| inline

Get whether to automatically flip the culling mode on objects whenever they are negatively scaled.

## ◆ _injectRenderWithPass()

void Ogre::SceneManager::_injectRenderWithPass | ( | Pass * | pass,
|  | Renderable * | rend,
|  | bool | shadowDerivation = true,
|  | bool | doLightIteration = false,
|  | const LightList * | manualLightList = 0 )

Render something as if it came from the current queue.

Parameters

  rend | The renderable to issue to the pipeline
  pass | The pass which is being used
  doLightIteration | If true, this method will issue the renderable to the pipeline possibly multiple times, if the pass indicates it should be done once per light
  manualLightList | Only applicable if doLightIteration is false, this method allows you to pass in a previously determined set of lights which will be used for a single render of this object.
  shadowDerivation | If false, disables the derivation of shadow passes from original passes

## ◆ _setPass()

const Pass * Ogre::SceneManager::_setPass | ( | const Pass * | pass,
|  | bool | shadowDerivation = true )

Internal method for setting up the renderstate for a rendering pass.

Parameters

  pass | The Pass details to set.
  shadowDerivation | If false, disables the derivation of shadow passes from original passes

Returns
  A Pass object that was used instead of the one passed in, can happen when rendering shadow passes

## ◆ _markGpuParamsDirty()

void Ogre::SceneManager::_markGpuParamsDirty | ( | uint16 | mask | ) |

Method to allow you to mark gpu parameters as dirty, causing them to be updated according to the mask that you set when updateGpuProgramParameters is next called.

Only really useful if you're controlling parameter state in inner rendering loop callbacks.

Parameters

  mask | Some combination of GpuParamVariability which is bitwise OR'ed with the current dirty state.

## ◆ _renderQueueGroupObjects()

void Ogre::SceneManager::_renderQueueGroupObjects | ( | RenderQueueGroup * | group,
|  | QueuedRenderableCollection::OrganisationMode | om )

Render the objects in a given queue group.

## ◆ setQueuedRenderableVisitor()

void Ogre::SceneManager::setQueuedRenderableVisitor | ( | SceneMgrQueuedRenderableVisitor * | visitor | ) |

Advanced method for supplying an alternative visitor, used for parsing the render queues and sending the results to the renderer.

You can use this method to insert your own implementation of the QueuedRenderableVisitor interface, which receives calls as the queued renderables are parsed in a given order and are sent to the renderer. If you provide your own implementation of this visitor, you are responsible for either calling the rendersystem, or passing the calls on to the base class implementation.

Note
  Ownership is not taken of this pointer, you are still required to delete it yourself once you're finished.

Parameters

  visitor | Your implementation of SceneMgrQueuedRenderableVisitor. If you pass 0, the default implementation will be used.

## ◆ getQueuedRenderableVisitor()

SceneMgrQueuedRenderableVisitor * Ogre::SceneManager::getQueuedRenderableVisitor | ( | void |  | ) | const
| inline

Gets the current visitor object which processes queued renderables.

## ◆ getDestinationRenderSystem()

RenderSystem * Ogre::SceneManager::getDestinationRenderSystem | ( |  | ) |

Get the rendersystem subclass to which the output of this Scene Manager gets sent.

## ◆ getCurrentViewport()

Viewport * Ogre::SceneManager::getCurrentViewport | ( | void |  | ) | const
| inline

Gets the current viewport being rendered (advanced use only, only valid during viewport update.

## ◆ getVisibleObjectsBoundsInfo()

const VisibleObjectsBoundsInfo & Ogre::SceneManager::getVisibleObjectsBoundsInfo | ( | const Camera * | cam | ) | const

Returns a visibility boundary box for a specific camera.

## ◆ getShadowCasterBoundsInfo()

const VisibleObjectsBoundsInfo & Ogre::SceneManager::getShadowCasterBoundsInfo | ( | const Light * | light,
|  | size_t | iteration = 0 ) const

Deprecated
  do not use

## ◆ addLodListener()

void Ogre::SceneManager::addLodListener | ( | LodListener * | listener | ) |

Add a level of detail listener.

## ◆ removeLodListener()

void Ogre::SceneManager::removeLodListener | ( | LodListener * | listener | ) |

Remove a level of detail listener.

Do not call from inside an LodListener callback method.

## ◆ _notifyMovableObjectLodChanged()

void Ogre::SceneManager::_notifyMovableObjectLodChanged | ( | MovableObjectLodChangedEvent & | evt | ) |

Notify that a movable object LOD change event has occurred.

## ◆ _notifyEntityMeshLodChanged()

void Ogre::SceneManager::_notifyEntityMeshLodChanged | ( | EntityMeshLodChangedEvent & | evt | ) |

Notify that an entity mesh LOD change event has occurred.

## ◆ _notifyEntityMaterialLodChanged()

void Ogre::SceneManager::_notifyEntityMaterialLodChanged | ( | EntityMaterialLodChangedEvent & | evt | ) |

Notify that an entity material LOD change event has occurred.

## ◆ _handleLodEvents()

void Ogre::SceneManager::_handleLodEvents | ( |  | ) |

Handle LOD events.

## ◆ _getCurrentRenderStage()

IlluminationRenderStage Ogre::SceneManager::_getCurrentRenderStage | ( |  | ) | const
| inline

## ◆ _getAutoParamDataSource()

const AutoParamDataSource * Ogre::SceneManager::_getAutoParamDataSource | ( |  | ) | const
| inline

## ◆ setVPRTCameras()

void Ogre::SceneManager::setVPRTCameras | ( | const std::vector< const Camera * > & | cameras | ) | const
| inline

## Member Data Documentation

## ◆ PT_PLANE

const char* Ogre::SceneManager::PT_PLANE = "Prefab_Plane"
| staticconstexpr

XY plane with -100..100 extent, +Z normal and UVs.

## ◆ PT_CUBE

const char* Ogre::SceneManager::PT_CUBE = "Prefab_Cube"
| staticconstexpr

100x100x100 cube centred at origin with normals and UVs

## ◆ PT_SPHERE

const char* Ogre::SceneManager::PT_SPHERE = "Prefab_Sphere"
| staticconstexpr

Sphere with radius 50, around origin with normals UVs

The documentation for this class was generated from the following file:

- OgreSceneManager.h